note

	description:

		"XPLain parser%
		%%
		%Parser derived from Xplain 5.8 manual%
		%(not yet complete, but we're getting there)%
		%%
		%Standard Xplain deviations:%
		%1. Supports additional representations for memo fields, %
		%   picture fields, .... %
		%2. Date field includes time.%
		%3. Supports renaming columns by using the `as' keyword."

	known_bugs:
	"3. Error reporting can be improved.%
	%4. No cascade support.%
	%5. Certain types of expressions are not always allowed, this is %
	%   not checked (use of values or constants for example).%
	%   A constant expression also accepts values if previously defined. %
	%   Should only accept constants.%
	%7. check constraint is not supported.%
	%9. purging inits is not yet supported.%
	%10. input is not supported.%
	%11. case keyword in inheritance not supported.%
	%12. It seems we're more strict in ordering of types than Xplain.%
	%    Generally, a type should exist, before you can use it as an %
	%    attribute.%
	%13. 'its' list parsing not strict enough. My accept an %
	%    attribute that is not correct. Probably dumps core later...%
	%15. names are case-sensitive, but should not be.%
	%16. No newline keyword support (parse as string??).%
	%17. Extend with explicitly given domain not supported.%
	%18. Doesn't check if a column used as boolean is really a boolean.%
	%    So 'get person where name' is ok.%
	%19. When there is an init for an attribute, no value is allowed %
	%    in insert. This is not checked although the input is overwritten.%
	%21. Don't put comments between a type and an init (default), else%
	%    the init (defaults) are silently ignored (2005-12-01: works slightly better now).%
	%23. update allows update a * its attr = 1, shouldn't allow *."

	author:     "Berend de Boer <berend@pobox.com>"


class

	XPLAIN_PARSER


inherit

	YY_PARSER_SKELETON
		rename
			make as make_parser_skeleton
		undefine
			report_error
		end

	XPLAIN_SCANNER
		rename
			make_with_file as make_scanner_with_file,
			make_with_stdin as make_scanner_with_stdin
		redefine
			write_pending_statement
		end

	XPLAIN_UNIVERSE_ACCESSOR
		export
			{NONE} all
		end


create

	make_with_file,
	make_with_stdin



feature {NONE} -- Implementation

	yy_build_parser_tables
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks
			-- Create value stacks.
		do
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
			create yyspecial_routines20
			yyvsc20 := yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.make (yyvsc20)
			create yyspecial_routines21
			yyvsc21 := yyInitial_yyvs_size
			yyvs21 := yyspecial_routines21.make (yyvsc21)
			create yyspecial_routines22
			yyvsc22 := yyInitial_yyvs_size
			yyvs22 := yyspecial_routines22.make (yyvsc22)
			create yyspecial_routines23
			yyvsc23 := yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.make (yyvsc23)
			create yyspecial_routines24
			yyvsc24 := yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.make (yyvsc24)
			create yyspecial_routines25
			yyvsc25 := yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.make (yyvsc25)
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
			create yyspecial_routines27
			yyvsc27 := yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.make (yyvsc27)
			create yyspecial_routines28
			yyvsc28 := yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.make (yyvsc28)
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
			create yyspecial_routines34
			yyvsc34 := yyInitial_yyvs_size
			yyvs34 := yyspecial_routines34.make (yyvsc34)
			create yyspecial_routines35
			yyvsc35 := yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.make (yyvsc35)
			create yyspecial_routines36
			yyvsc36 := yyInitial_yyvs_size
			yyvs36 := yyspecial_routines36.make (yyvsc36)
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
			create yyspecial_routines38
			yyvsc38 := yyInitial_yyvs_size
			yyvs38 := yyspecial_routines38.make (yyvsc38)
			create yyspecial_routines39
			yyvsc39 := yyInitial_yyvs_size
			yyvs39 := yyspecial_routines39.make (yyvsc39)
			create yyspecial_routines40
			yyvsc40 := yyInitial_yyvs_size
			yyvs40 := yyspecial_routines40.make (yyvsc40)
			create yyspecial_routines41
			yyvsc41 := yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.make (yyvsc41)
			create yyspecial_routines42
			yyvsc42 := yyInitial_yyvs_size
			yyvs42 := yyspecial_routines42.make (yyvsc42)
			create yyspecial_routines43
			yyvsc43 := yyInitial_yyvs_size
			yyvs43 := yyspecial_routines43.make (yyvsc43)
			create yyspecial_routines44
			yyvsc44 := yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.make (yyvsc44)
			create yyspecial_routines45
			yyvsc45 := yyInitial_yyvs_size
			yyvs45 := yyspecial_routines45.make (yyvsc45)
			create yyspecial_routines46
			yyvsc46 := yyInitial_yyvs_size
			yyvs46 := yyspecial_routines46.make (yyvsc46)
			create yyspecial_routines47
			yyvsc47 := yyInitial_yyvs_size
			yyvs47 := yyspecial_routines47.make (yyvsc47)
			create yyspecial_routines48
			yyvsc48 := yyInitial_yyvs_size
			yyvs48 := yyspecial_routines48.make (yyvsc48)
			create yyspecial_routines49
			yyvsc49 := yyInitial_yyvs_size
			yyvs49 := yyspecial_routines49.make (yyvsc49)
			create yyspecial_routines50
			yyvsc50 := yyInitial_yyvs_size
			yyvs50 := yyspecial_routines50.make (yyvsc50)
		end

	yy_init_value_stacks
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
			yyvsp8 := -1
			yyvsp9 := -1
			yyvsp10 := -1
			yyvsp11 := -1
			yyvsp12 := -1
			yyvsp13 := -1
			yyvsp14 := -1
			yyvsp15 := -1
			yyvsp16 := -1
			yyvsp17 := -1
			yyvsp18 := -1
			yyvsp19 := -1
			yyvsp20 := -1
			yyvsp21 := -1
			yyvsp22 := -1
			yyvsp23 := -1
			yyvsp24 := -1
			yyvsp25 := -1
			yyvsp26 := -1
			yyvsp27 := -1
			yyvsp28 := -1
			yyvsp29 := -1
			yyvsp30 := -1
			yyvsp31 := -1
			yyvsp32 := -1
			yyvsp33 := -1
			yyvsp34 := -1
			yyvsp35 := -1
			yyvsp36 := -1
			yyvsp37 := -1
			yyvsp38 := -1
			yyvsp39 := -1
			yyvsp40 := -1
			yyvsp41 := -1
			yyvsp42 := -1
			yyvsp43 := -1
			yyvsp44 := -1
			yyvsp45 := -1
			yyvsp46 := -1
			yyvsp47 := -1
			yyvsp48 := -1
			yyvsp49 := -1
			yyvsp50 := -1
		end

	yy_clear_value_stacks
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			yyvs1.keep_head (0)
			yyvs2.keep_head (0)
			yyvs3.keep_head (0)
			yyvs4.keep_head (0)
			yyvs5.keep_head (0)
			yyvs6.keep_head (0)
			yyvs7.keep_head (0)
			yyvs8.keep_head (0)
			yyvs9.keep_head (0)
			yyvs10.keep_head (0)
			yyvs11.keep_head (0)
			yyvs12.keep_head (0)
			yyvs13.keep_head (0)
			yyvs14.keep_head (0)
			yyvs15.keep_head (0)
			yyvs16.keep_head (0)
			yyvs17.keep_head (0)
			yyvs18.keep_head (0)
			yyvs19.keep_head (0)
			yyvs20.keep_head (0)
			yyvs21.keep_head (0)
			yyvs22.keep_head (0)
			yyvs23.keep_head (0)
			yyvs24.keep_head (0)
			yyvs25.keep_head (0)
			yyvs26.keep_head (0)
			yyvs27.keep_head (0)
			yyvs28.keep_head (0)
			yyvs29.keep_head (0)
			yyvs30.keep_head (0)
			yyvs31.keep_head (0)
			yyvs32.keep_head (0)
			yyvs33.keep_head (0)
			yyvs34.keep_head (0)
			yyvs35.keep_head (0)
			yyvs36.keep_head (0)
			yyvs37.keep_head (0)
			yyvs38.keep_head (0)
			yyvs39.keep_head (0)
			yyvs40.keep_head (0)
			yyvs41.keep_head (0)
			yyvs42.keep_head (0)
			yyvs43.keep_head (0)
			yyvs44.keep_head (0)
			yyvs45.keep_head (0)
			yyvs46.keep_head (0)
			yyvs47.keep_head (0)
			yyvs48.keep_head (0)
			yyvs49.keep_head (0)
			yyvs50.keep_head (0)
		end

	yy_push_last_value (yychar1: INTEGER)
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
				end
				yyspecial_routines1.force (yyvs1, last_detachable_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs2")
					end
					yyvsc2 := yyvsc2 + yyInitial_yyvs_size
					yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
				end
				yyspecial_routines2.force (yyvs2, last_string_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs3")
					end
					yyvsc3 := yyvsc3 + yyInitial_yyvs_size
					yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
				end
				yyspecial_routines3.force (yyvs3, last_integer_value, yyvsp3)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: detachable ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				debug ("GEYACC")
					std.error.put_line ("Resize yyvs1")
				end
				yyvsc1 := yyvsc1 + yyInitial_yyvs_size
				yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
			end
			yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER)
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			when 8 then
				yyvsp8 := yyvsp8 - 1
			when 9 then
				yyvsp9 := yyvsp9 - 1
			when 10 then
				yyvsp10 := yyvsp10 - 1
			when 11 then
				yyvsp11 := yyvsp11 - 1
			when 12 then
				yyvsp12 := yyvsp12 - 1
			when 13 then
				yyvsp13 := yyvsp13 - 1
			when 14 then
				yyvsp14 := yyvsp14 - 1
			when 15 then
				yyvsp15 := yyvsp15 - 1
			when 16 then
				yyvsp16 := yyvsp16 - 1
			when 17 then
				yyvsp17 := yyvsp17 - 1
			when 18 then
				yyvsp18 := yyvsp18 - 1
			when 19 then
				yyvsp19 := yyvsp19 - 1
			when 20 then
				yyvsp20 := yyvsp20 - 1
			when 21 then
				yyvsp21 := yyvsp21 - 1
			when 22 then
				yyvsp22 := yyvsp22 - 1
			when 23 then
				yyvsp23 := yyvsp23 - 1
			when 24 then
				yyvsp24 := yyvsp24 - 1
			when 25 then
				yyvsp25 := yyvsp25 - 1
			when 26 then
				yyvsp26 := yyvsp26 - 1
			when 27 then
				yyvsp27 := yyvsp27 - 1
			when 28 then
				yyvsp28 := yyvsp28 - 1
			when 29 then
				yyvsp29 := yyvsp29 - 1
			when 30 then
				yyvsp30 := yyvsp30 - 1
			when 31 then
				yyvsp31 := yyvsp31 - 1
			when 32 then
				yyvsp32 := yyvsp32 - 1
			when 33 then
				yyvsp33 := yyvsp33 - 1
			when 34 then
				yyvsp34 := yyvsp34 - 1
			when 35 then
				yyvsp35 := yyvsp35 - 1
			when 36 then
				yyvsp36 := yyvsp36 - 1
			when 37 then
				yyvsp37 := yyvsp37 - 1
			when 38 then
				yyvsp38 := yyvsp38 - 1
			when 39 then
				yyvsp39 := yyvsp39 - 1
			when 40 then
				yyvsp40 := yyvsp40 - 1
			when 41 then
				yyvsp41 := yyvsp41 - 1
			when 42 then
				yyvsp42 := yyvsp42 - 1
			when 43 then
				yyvsp43 := yyvsp43 - 1
			when 44 then
				yyvsp44 := yyvsp44 - 1
			when 45 then
				yyvsp45 := yyvsp45 - 1
			when 46 then
				yyvsp46 := yyvsp46 - 1
			when 47 then
				yyvsp47 := yyvsp47 - 1
			when 48 then
				yyvsp48 := yyvsp48 - 1
			when 49 then
				yyvsp49 := yyvsp49 - 1
			when 50 then
				yyvsp50 := yyvsp50 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_run_geyacc
			-- You must run geyacc to regenerate this class.
		do
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER)
			-- Execute semantic action.
		local
			yyval1: detachable ANY
			yyval2: STRING
			yyval38: detachable XPLAIN_STATEMENT
			yyval40: detachable XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT
			yyval4: XPLAIN_BASE
			yyval15: detachable XPLAIN_TYPE
			yyval39: detachable XPLAIN_CONSTANT_STATEMENT
			yyval6: XPLAIN_DOMAIN_RESTRICTION
			yyval7: XPLAIN_A_NODE
			yyval8: XPLAIN_I_NODE
			yyval9: XPLAIN_LOGICAL_EXPRESSION
			yyval10: XPLAIN_EXPRESSION
			yyval11: XPLAIN_LOGICAL_VALUE_EXPRESSION
			yyval12: XPLAIN_SYSTEM_EXPRESSION
			yyval13: XPLAIN_ATTRIBUTE_NAME_NODE
			yyval14: XPLAIN_ATTRIBUTE_NAME
			yyval16: detachable XPLAIN_EXPRESSION
			yyval17: XPLAIN_REPRESENTATION
			yyval18: XPLAIN_PK_REPRESENTATION
			yyval19: detachable XPLAIN_ATTRIBUTE_NODE
			yyval20: XPLAIN_ATTRIBUTE
			yyval3: INTEGER
			yyval5: detachable XPLAIN_DOMAIN_RESTRICTION
			yyval21: detachable XPLAIN_ASSERTION
			yyval22: detachable XPLAIN_ATTRIBUTE_NAME_NODE
			yyval23: detachable XPLAIN_ASSIGNMENT_NODE
			yyval24: XPLAIN_ASSIGNMENT
			yyval41: detachable XPLAIN_CASCADE_STATEMENT
			yyval42: detachable XPLAIN_CASCADE_FUNCTION_EXPRESSION
			yyval43: detachable XPLAIN_DELETE_STATEMENT
			yyval25: detachable XPLAIN_SUBJECT
			yyval48: detachable XPLAIN_UPDATE_STATEMENT
			yyval49: XPLAIN_VALUE_STATEMENT
			yyval50: detachable XPLAIN_VALUE_SELECTION_STATEMENT
			yyval26: detachable XPLAIN_NON_ATTRIBUTE_EXPRESSION
			yyval27: detachable XPLAIN_SELECTION_FUNCTION
			yyval45: detachable XPLAIN_GET_STATEMENT
			yyval44: detachable XPLAIN_EXTEND_STATEMENT
			yyval28: detachable XPLAIN_EXTENSION
			yyval29: XPLAIN_EXTEND_ATTRIBUTE
			yyval30: detachable XPLAIN_EXTENSION_EXPRESSION
			yyval31: detachable XPLAIN_SELECTION
			yyval32: detachable XPLAIN_SELECTION_LIST
			yyval33: detachable XPLAIN_SORT_NODE
			yyval34: XPLAIN_FUNCTION
			yyval35: detachable XPLAIN_EXPRESSION_NODE
			yyval36: detachable STRING
			yyval46: detachable XPLAIN_PROCEDURE_STATEMENT
			yyval47: XPLAIN_SQL_STATEMENT
			yyval37: detachable XPLAIN_STATEMENT_NODE
		do
				inspect yy_act
when 1 then
--|#line 284 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 284")
end

			write_pending_statement
			sqlgenerator.write_end (yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 2 then
--|#line 289 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 289")
end

			report_error ("Additional end detected after parsing the end belonging to the database command.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 3 then
--|#line 294 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 294")
end

			report_error ("Additional input after end of database.: " + text)
			abort
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 4 then
--|#line 299 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 299")
end

			report_error ("Script should start with the 'database' command instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 5 then
--|#line 307 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 307")
end

			sqlgenerator.write_use_database (yyvs2.item (yyvsp2))
			yyval2 := yyvs2.item (yyvsp2)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 6 then
--|#line 315 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 315")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 7 then
--|#line 320 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 320")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 8 then
--|#line 321 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 321")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 9 then
--|#line 325 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 325")
end

			if not use_mode then
				if attached yyvs38.item (yyvsp38) as s then -- because statement support is partial at the moment
					statements.add (s)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp38 := yyvsp38 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 10 then
--|#line 333 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 333")
end

statements.add (yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp47 := yyvsp47 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 11 then
--|#line 335 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 335")
end

statements.add (yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp47 := yyvsp47 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 12 then
--|#line 337 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 337")
end

			if not use_mode then
				if attached yyvs38.item (yyvsp38) as s then -- because statement support is partial at the moment
					statements.add (s)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp38 := yyvsp38 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 13 then
--|#line 345 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 345")
end

			if equal (text, "end") then
				report_error ("Unexpected 'end'. '.' missing?")
				abort
			elseif equal (text, "") then
				report_error ("Unexpected end of input. 'end.' missing?")
				abort
			else
				report_error ("Unknown or unexpected command: " + text)
				abort
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 14 then
--|#line 361 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 361")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 15 then
--|#line 363 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 363")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 16 then
--|#line 365 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 365")
end

yyval38 := yyvs46.item (yyvsp46) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp46 := yyvsp46 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 17 then
--|#line 375 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 375")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 18 then
--|#line 377 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 377")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 19 then
--|#line 379 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 379")
end

yyval38 := yyvs40.item (yyvsp40) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp40 := yyvsp40 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 20 then
--|#line 384 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 384")
end

			if attached yyvs15.item (yyvsp15) as t then
				create {XPLAIN_TYPE_STATEMENT} yyval38.make (t)
				universe.add (t, Current)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 21 then
--|#line 391 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 391")
end

			create {XPLAIN_BASE_STATEMENT} yyval38.make (yyvs4.item (yyvsp4))
			if not use_mode then
				sqlgenerator.write_base(yyvs4.item (yyvsp4))
			end
			universe.add(yyvs4.item (yyvsp4), Current)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 22 then
--|#line 399 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 399")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 23 then
--|#line 400 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 400")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 24 then
--|#line 401 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 401")
end

yyval38 := yyvs39.item (yyvsp39) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp39 := yyvsp39 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 25 then
--|#line 404 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 404")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 26 then
--|#line 405 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 405")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 27 then
--|#line 407 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 407")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 28 then
--|#line 411 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 411")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 29 then
--|#line 413 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 413")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 30 then
--|#line 418 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 418")
end

			write_pending_statement
			if attached universe.find_variable(yyvs2.item (yyvsp2)) as variable then
				if not variable.has_value then
					if not use_mode then
						sqlgenerator.write_constant_assignment (variable, yyvs10.item (yyvsp10))
					end
					variable.set_value (yyvs10.item (yyvsp10))
					create yyval40.make (variable, yyvs10.item (yyvsp10))
				else
					report_error ("Constant `" + yyvs2.item (yyvsp2) + "' has already been assigned a value.")
					abort
				end
			else
				report_error ("Not a valid constant: " + yyvs2.item (yyvsp2))
				abort
			end
			constant_mode := False
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvsp10 := yyvsp10 -1
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
when 31 then
--|#line 418 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 418")
end

constant_mode := True 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp40 := yyvsp40 + 1
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
when 32 then
--|#line 438 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 438")
end

			constant_mode := False
			report_error ("A constant assignment expression should be surrounded by parentheses")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp40 := yyvsp40 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
when 33 then
--|#line 449 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 449")
end

		write_pending_statement
		yyval4 := new_base (yyvs2.item (yyvsp2), yyvs17.item (yyvsp17), False)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp4 >= yyvsc4 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs4")
		end
		yyvsc4 := yyvsc4 + yyInitial_yyvs_size
		yyvs4 := yyspecial_routines4.aliased_resized_area (yyvs4, yyvsc4)
	end
	yyspecial_routines4.force (yyvs4, yyval4, yyvsp4)
end
when 34 then
--|#line 454 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 454")
end

		write_pending_statement
		yyval4 := new_base (yyvs2.item (yyvsp2), yyvs17.item (yyvsp17), True)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp4 >= yyvsc4 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs4")
		end
		yyvsc4 := yyvsc4 + yyInitial_yyvs_size
		yyvs4 := yyspecial_routines4.aliased_resized_area (yyvs4, yyvsc4)
	end
	yyspecial_routines4.force (yyvs4, yyval4, yyvsp4)
end
when 35 then
--|#line 459 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 459")
end

		write_pending_statement
		yyvs17.item (yyvsp17).set_domain_restriction (sqlgenerator, yyvs6.item (yyvsp6))
		yyval4 := new_base (yyvs2.item (yyvsp2), yyvs17.item (yyvsp17), False)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	yyvsp6 := yyvsp6 -1
	if yyvsp4 >= yyvsc4 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs4")
		end
		yyvsc4 := yyvsc4 + yyInitial_yyvs_size
		yyvs4 := yyspecial_routines4.aliased_resized_area (yyvs4, yyvsc4)
	end
	yyspecial_routines4.force (yyvs4, yyval4, yyvsp4)
end
when 36 then
--|#line 468 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 468")
end

			write_pending_statement
			if attached yyvs19.item (yyvsp19) as al then
				create yyval15.make (yyvs2.item (yyvsp2), yyvs18.item (yyvsp18), al)
				pending_type := yyval15
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp18 := yyvsp18 -1
	yyvsp19 := yyvsp19 -1
	if yyvsp15 >= yyvsc15 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs15")
		end
		yyvsc15 := yyvsc15 + yyInitial_yyvs_size
		yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
	end
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
when 37 then
--|#line 479 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 479")
end

			if pending_init /= yyvs15.item (yyvsp15) then
				write_pending_init
			end
			if attached yyvs15.item (yyvsp15) then
				pending_init := yyvs15.item (yyvsp15)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp15 := yyvsp15 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 38 then
--|#line 479 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 479")
end

is_init_default := False 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 39 then
--|#line 493 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 493")
end

			if pending_init /= yyvs15.item (yyvsp15) then
				write_pending_init
			end
			if attached yyvs15.item (yyvsp15) then
				pending_init := yyvs15.item (yyvsp15)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp15 := yyvsp15 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 40 then
--|#line 493 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 493")
end

is_init_default := True 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 41 then
--|#line 507 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 507")
end

			write_pending_statement
			create {XPLAIN_REQUIRED} dummyrestriction.make (False)
			yyvs17.item (yyvsp17).set_domain_restriction (sqlgenerator, dummyrestriction)
			create myvariable.make (yyvs2.item (yyvsp2), yyvs17.item (yyvsp17))
			if attached myvariable as v then
				if not use_mode then
					sqlgenerator.write_constant (v)
				end
				universe.add(v, Current)
				create yyval39.make (v)
			end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp39 := yyvsp39 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
when 42 then
--|#line 523 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 523")
end

write_pending_statement
		if attached get_known_object (yyvs2.item (yyvsp2)) as myobject then
			if immediate_output_mode then
				sqlgenerator.write_drop (myobject)
			end
			universe.delete (myobject)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 43 then
--|#line 535 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 535")
end

			write_pending_statement
			if attached subject_type as t and then attached t.find_attribute (yyvs14.item (yyvsp14)) as myattribute then
				if immediate_output_mode then
					t.write_drop_attribute	(sqlgenerator, myattribute)
				end
			else
				error_unknown_attribute (yyvs2.item (yyvsp2), yyvs14.item (yyvsp14))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 44 then
--|#line 535 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 535")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp38 := yyvsp38 + 1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 45 then
--|#line 547 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 547")
end

report_warning ("Purging of inits is not yet supported.") 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 46 then
--|#line 547 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 547")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp38 := yyvsp38 + 1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 47 then
--|#line 554 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 554")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 48 then
--|#line 556 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 556")
end

create {XPLAIN_A_PATTERN} yyval6.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp6 >= yyvsc6 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs6")
		end
		yyvsc6 := yyvsc6 + yyInitial_yyvs_size
		yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
	end
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 49 then
--|#line 558 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 558")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 50 then
--|#line 560 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 560")
end

			report_error ("Domain restriction not supported for this data type or error in domain restriction definition.")
			abort
			-- silence compiler:
			create {XPLAIN_A_PATTERN} yyval6.make ("")
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs6")
		end
		yyvsc6 := yyvsc6 + yyInitial_yyvs_size
		yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
	end
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 51 then
--|#line 570 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 570")
end

create {XPLAIN_A_ENUMERATION} yyval6.make (yyvs7.item (yyvsp7)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp6 >= yyvsc6 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs6")
		end
		yyvsc6 := yyvsc6 + yyInitial_yyvs_size
		yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
	end
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 52 then
--|#line 572 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 572")
end

create {XPLAIN_I_ENUMERATION} yyval6.make (yyvs8.item (yyvsp8)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp8 := yyvsp8 -1
	if yyvsp6 >= yyvsc6 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs6")
		end
		yyvsc6 := yyvsc6 + yyInitial_yyvs_size
		yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
	end
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 53 then
--|#line 577 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 577")
end

create {XPLAIN_A_NODE} yyval7.make (yyvs2.item (yyvsp2), void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp7 := yyvsp7 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp7 >= yyvsc7 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs7")
		end
		yyvsc7 := yyvsc7 + yyInitial_yyvs_size
		yyvs7 := yyspecial_routines7.aliased_resized_area (yyvs7, yyvsc7)
	end
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
when 54 then
--|#line 579 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 579")
end

create {XPLAIN_A_NODE} yyval7.make (yyvs2.item (yyvsp2), yyvs7.item (yyvsp7)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
when 55 then
--|#line 584 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 584")
end

create {XPLAIN_I_NODE} yyval8.make (yyvs3.item (yyvsp3), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp8 := yyvsp8 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp8 >= yyvsc8 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs8")
		end
		yyvsc8 := yyvsc8 + yyInitial_yyvs_size
		yyvs8 := yyspecial_routines8.aliased_resized_area (yyvs8, yyvsc8)
	end
	yyspecial_routines8.force (yyvs8, yyval8, yyvsp8)
end
when 56 then
--|#line 586 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 586")
end

create {XPLAIN_I_NODE} yyval8.make (yyvs3.item (yyvsp3), yyvs8.item (yyvsp8)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines8.force (yyvs8, yyval8, yyvsp8)
end
when 57 then
--|#line 588 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 588")
end

			report_error ("An integer enumeration cannot contain a %"..%". If you want to specify a trajectory, the format should be (I2) (1..*) for example.")
			abort
			-- silence compiler:
			create {XPLAIN_I_NODE} yyval8.make (0, Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp8 := yyvsp8 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp8 >= yyvsc8 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs8")
		end
		yyvsc8 := yyvsc8 + yyInitial_yyvs_size
		yyvs8 := yyspecial_routines8.aliased_resized_area (yyvs8, yyvsc8)
	end
	yyspecial_routines8.force (yyvs8, yyval8, yyvsp8)
end
when 58 then
--|#line 598 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 598")
end

			if yyvs2.item (yyvsp2 - 1).is_integer and then yyvs2.item (yyvsp2).is_integer then
				if yyvs2.item (yyvsp2 - 1).to_integer > yyvs2.item (yyvsp2).to_integer then
					report_error ("Trajectory's lower value " + yyvs2.item (yyvsp2 - 1) + " is more than the upper value " + yyvs2.item (yyvsp2) + ".")
					abort
				end
			end
			create {XPLAIN_TRAJECTORY} yyval6.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	if yyvsp6 >= yyvsc6 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs6")
		end
		yyvsc6 := yyvsc6 + yyInitial_yyvs_size
		yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
	end
	yyspecial_routines6.force (yyvs6, yyval6, yyvsp6)
end
when 59 then
--|#line 611 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 611")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 60 then
--|#line 613 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 613")
end

			create yyval2.make_filled ('9', last_width)
			yyval2.insert_character ('-', 1)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 61 then
--|#line 621 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 621")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 62 then
--|#line 623 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 623")
end

create yyval2.make_filled ('9', last_width) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 63 then
--|#line 628 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 628")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 64 then
--|#line 632 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 632")
end

yyval2 := "+" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 65 then
--|#line 634 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 634")
end

yyval2 := "-" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 66 then
--|#line 638 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 638")
end

yyval2 := "*" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 67 then
--|#line 640 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 640")
end

yyval2 := "/" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 68 then
--|#line 642 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 642")
end

yyval2 := "%%" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 69 then
--|#line 647 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 647")
end

			yyval9 := new_logical_expression (yyvs10.item (yyvsp10), once "or", yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
when 70 then
--|#line 651 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 651")
end

			create yyval9.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs9")
		end
		yyvsc9 := yyvsc9 + yyInitial_yyvs_size
		yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
	end
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
when 71 then
--|#line 658 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 658")
end

create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), once "and", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 72 then
--|#line 660 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 660")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 73 then
--|#line 670 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 670")
end

			-- silence compiler, we either return something valid or abort:
			create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False)
			if attached subject_type then
				if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and then attached last_object_in_tree as o then
					-- the last object in the tree knows what expression to build here
					if attached o.create_expression (yyvs13.item (yyvsp13)) as e then
						if e.is_logical_expression then
							create {XPLAIN_NOTNOT_EXPRESSION} yyval10.make (e)
						else
							yyval10 := e
						end
					end
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 74 then
--|#line 690 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 690")
end

			if attached subject_type then
				if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and then attached last_object_in_tree as o and then attached o.create_expression (yyvs13.item (yyvsp13)) as e then
					-- the last object in the tree knows what expression to build here
					create {XPLAIN_NOT_EXPRESSION} yyval10.make (e)
				else
					-- silence compiler, we either return something valid or abort:
					create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False)
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False)
			end

		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 75 then
--|#line 708 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 708")
end

			if is_parameter_declared (yyvs14.item (yyvsp14)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14))
			else
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False)
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 76 then
--|#line 717 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 717")
end

			if is_parameter_declared (yyvs14.item (yyvsp14)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14))
				create {XPLAIN_NOT_EXPRESSION} yyval10.make (yyval10)
			else
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False)
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 77 then
--|#line 727 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 727")
end

create {XPLAIN_EQ_NULL_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 78 then
--|#line 729 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 729")
end

create {XPLAIN_NE_NULL_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 79 then
--|#line 731 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 731")
end

			yyval10 := new_logical_infix_expression (yyvs10.item (yyvsp10 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 80 then
--|#line 735 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 735")
end

			create {XPLAIN_NOT_EXPRESSION} yyval10.make (new_logical_infix_expression (yyvs10.item (yyvsp10 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 81 then
--|#line 739 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 739")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 82 then
--|#line 741 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 741")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs9.item (yyvsp9))
		  create {XPLAIN_NOT_EXPRESSION} yyval10.make (yyval10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 83 then
--|#line 744 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 744")
end

yyval10 := yyvs11.item (yyvsp11) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp11 := yyvsp11 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 84 then
--|#line 746 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 746")
end

create {XPLAIN_NOT_EXPRESSION} yyval10.make (yyvs11.item (yyvsp11)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp11 := yyvsp11 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 85 then
--|#line 750 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 750")
end

yyval2 := "<" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 86 then
--|#line 752 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 752")
end

yyval2 := "<=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 87 then
--|#line 754 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 754")
end

yyval2 := ">" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 88 then
--|#line 756 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 756")
end

yyval2 := ">=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 89 then
--|#line 758 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 758")
end

yyval2 := "=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 90 then
--|#line 760 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 760")
end

yyval2 := "<>" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 91 then
--|#line 765 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 765")
end

create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval11.make (True) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp11 := yyvsp11 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp11 >= yyvsc11 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs11")
		end
		yyvsc11 := yyvsc11 + yyInitial_yyvs_size
		yyvs11 := yyspecial_routines11.aliased_resized_area (yyvs11, yyvsc11)
	end
	yyspecial_routines11.force (yyvs11, yyval11, yyvsp11)
end
when 92 then
--|#line 767 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 767")
end

create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval11.make (False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp11 := yyvsp11 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp11 >= yyvsc11 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs11")
		end
		yyvsc11 := yyvsc11 + yyInitial_yyvs_size
		yyvs11 := yyspecial_routines11.aliased_resized_area (yyvs11, yyvsc11)
	end
	yyspecial_routines11.force (yyvs11, yyval11, yyvsp11)
end
when 93 then
--|#line 772 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 772")
end

create {XPLAIN_SYSTEMDATE_EXPRESSION} yyval12 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp12 := yyvsp12 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp12 >= yyvsc12 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs12")
		end
		yyvsc12 := yyvsc12 + yyInitial_yyvs_size
		yyvs12 := yyspecial_routines12.aliased_resized_area (yyvs12, yyvsc12)
	end
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
when 94 then
--|#line 774 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 774")
end

create {XPLAIN_LOGINNAME_EXPRESSION} yyval12 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp12 := yyvsp12 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp12 >= yyvsc12 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs12")
		end
		yyvsc12 := yyvsc12 + yyInitial_yyvs_size
		yyvs12 := yyspecial_routines12.aliased_resized_area (yyvs12, yyvsc12)
	end
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
when 95 then
--|#line 779 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 779")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 96 then
--|#line 781 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 781")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 97 then
--|#line 783 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 783")
end

create {XPLAIN_IF_EXPRESSION} yyval10.make (yyvs9.item (yyvsp9), yyvs10.item (yyvsp10 - 1), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -3
	yyvsp9 := yyvsp9 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 98 then
--|#line 788 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 788")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 99 then
--|#line 790 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 790")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 100 then
--|#line 795 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 795")
end

			-- we have something here that can be an
			-- attribute/extension/value/variable.
			-- let's get the correct object associated with this tree
			if attached subject_type as s then
				if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and then attached last_object_in_tree as last_object then
					-- the last object in the tree knows what expression to build here
					yyval10 := last_object.create_expression (yyvs13.item (yyvsp13))
				else
					abort
					-- silence compiler, we either return something valid or abort:
					create {XPLAIN_LOGINNAME_EXPRESSION} yyval10
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGINNAME_EXPRESSION} yyval10
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 101 then
--|#line 816 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 816")
end

			if attached subject_type then
				if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and then attached last_object_in_tree as last_object then
					-- the last object in the tree knows what expression to build here
					create {XPLAIN_PREFIX_EXPRESSION} yyval10.make ("-", last_object.create_expression (yyvs13.item (yyvsp13)))
				else
					-- silence compiler, we either return something valid or abort:
					create {XPLAIN_LOGINNAME_EXPRESSION} yyval10
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 102 then
--|#line 832 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 832")
end

yyval10 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 103 then
--|#line 836 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 836")
end

			if attached yyvs35.item (yyvsp35) as pl then
				create {XPLAIN_COMBINE_FUNCTION} yyval10.make (pl)
			else
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp35 := yyvsp35 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 104 then
--|#line 848 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 848")
end

			create {XPLAIN_DATEF_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 105 then
--|#line 852 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 852")
end

			create {XPLAIN_INTEGER_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 106 then
--|#line 856 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 856")
end

			create {XPLAIN_REAL_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 107 then
--|#line 860 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 860")
end

			create {XPLAIN_STRING_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 108 then
--|#line 866 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 866")
end

			create {XPLAIN_NEWDATE_FUNCTION} yyval10.make (yyvs10.item (yyvsp10 - 1), yyvs10.item (yyvsp10), newdate_default_days)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -3
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 109 then
--|#line 870 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 870")
end

			create {XPLAIN_NEWDATE_FUNCTION} yyval10.make (yyvs10.item (yyvsp10 - 2), yyvs10.item (yyvsp10 - 1), yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp10 := yyvsp10 -2
	yyvsp1 := yyvsp1 -4
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 110 then
--|#line 879 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 879")
end

			if attached subject_type as t then
				create {XPLAIN_ID_FUNCTION} yyval10.make (t)
			else
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGINNAME_EXPRESSION} yyval10
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 111 then
--|#line 889 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 889")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 112 then
--|#line 891 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 891")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10))
		  create {XPLAIN_PREFIX_EXPRESSION} yyval10.make ("-", yyval10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 113 then
--|#line 894 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 894")
end

create {XPLAIN_STRING_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 114 then
--|#line 896 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 896")
end

create {XPLAIN_NUMBER_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 115 then
--|#line 898 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 898")
end

yyval10 := yyvs11.item (yyvsp11) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp11 := yyvsp11 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 116 then
--|#line 900 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 900")
end

create {XPLAIN_UNMANAGED_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14).full_name) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 117 then
--|#line 902 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 902")
end

			if is_parameter_declared (yyvs14.item (yyvsp14)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14))
			else
				-- silence compiler, we either return something valid or abort:
				create {XPLAIN_LOGINNAME_EXPRESSION} yyval10
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 118 then
--|#line 913 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 913")
end

			create {XPLAIN_USER_FUNCTION} yyval10.make (yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 119 then
--|#line 917 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 917")
end

			create {XPLAIN_USER_FUNCTION} yyval10.make (yyvs2.item (yyvsp2), yyvs35.item (yyvsp35))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp35 := yyvsp35 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 120 then
--|#line 923 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 923")
end

create {XPLAIN_SQL_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 121 then
--|#line 927 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 927")
end

yyval2 := yyvs3.item (yyvsp3).out 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 122 then
--|#line 929 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 929")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 123 then
--|#line 934 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 934")
end

create yyval13.make (yyvs14.item (yyvsp14), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp13 := yyvsp13 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp13 >= yyvsc13 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs13")
		end
		yyvsc13 := yyvsc13 + yyInitial_yyvs_size
		yyvs13 := yyspecial_routines13.aliased_resized_area (yyvs13, yyvsc13)
	end
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
when 124 then
--|#line 936 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 936")
end

create yyval13.make (yyvs14.item (yyvsp14), yyvs13.item (yyvsp13)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
when 125 then
--|#line 942 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 942")
end

create yyval14.make (Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 126 then
--|#line 944 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 944")
end

create yyval14.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 127 then
--|#line 949 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 949")
end

yyval14 := yyvs14.item (yyvsp14) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 128 then
--|#line 953 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 953")
end

			if attached subject_type as t and then attached t.find_attribute (yyvs14.item (yyvsp14)) as myattribute then
				if attached myattribute.init then
					report_warning (format ("Attribute `$s' already has an initialization expression.", <<myattribute.full_name>>))
				end
				if attached yyvs16.item (yyvsp16) as s then
					if is_init_default then
						myattribute.set_init_default (s)
					else
						myattribute.set_init (s)
					end
				end
				yyval15 := t
			else
				error_unknown_attribute (yyvs2.item (yyvsp2), yyvs14.item (yyvsp14))
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp14 := yyvsp14 -1
	yyvsp16 := yyvsp16 -1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
when 129 then
--|#line 953 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 953")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp15 := yyvsp15 + 1
	if yyvsp15 >= yyvsc15 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs15")
		end
		yyvsc15 := yyvsc15 + yyInitial_yyvs_size
		yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
	end
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
when 130 then
--|#line 977 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 977")
end

yyval16 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 131 then
--|#line 979 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 979")
end

yyval16 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 132 then
--|#line 981 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 981")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -4
	yyvsp10 := yyvsp10 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 133 then
--|#line 985 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 985")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
when 134 then
--|#line 990 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 990")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 135 then
--|#line 995 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 995")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 136 then
--|#line 998 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 998")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 137 then
--|#line 999 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 999")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 138 then
--|#line 1002 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1002")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp16 := yyvsp16 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 139 then
--|#line 1005 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1005")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 140 then
--|#line 1006 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1006")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 141 then
--|#line 1009 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1009")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp16 := yyvsp16 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 142 then
--|#line 1013 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1013")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_A_REPRESENTATION} yyval17.make (last_width)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 143 then
--|#line 1018 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1018")
end

create {XPLAIN_B_REPRESENTATION} yyval17 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 144 then
--|#line 1020 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1020")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_C_REPRESENTATION} yyval17.make (last_width)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 145 then
--|#line 1025 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1025")
end

create {XPLAIN_D_REPRESENTATION} yyval17 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 146 then
--|#line 1027 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1027")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_I_REPRESENTATION} yyval17.make (yyvs3.item (yyvsp3))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 147 then
--|#line 1032 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1032")
end

create {XPLAIN_M_REPRESENTATION} yyval17 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 148 then
--|#line 1034 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1034")
end

create {XPLAIN_P_REPRESENTATION} yyval17 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 149 then
--|#line 1036 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1036")
end

			last_width := yyvs3.item (yyvsp3 - 1)
			create {XPLAIN_R_REPRESENTATION} yyval17.make (yyvs3.item (yyvsp3 - 1), yyvs3.item (yyvsp3))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp3 := yyvsp3 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 150 then
--|#line 1041 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1041")
end

create {XPLAIN_T_REPRESENTATION} yyval17 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 151 then
--|#line 1043 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1043")
end

			report_error ("Comma expected in R representation instead of: " + text)
			abort
			-- silence compiler:
			create {XPLAIN_B_REPRESENTATION} yyval17
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 152 then
--|#line 1050 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1050")
end

			report_error ("Representation expected instead of: " + text)
			abort
			-- silence compiler:
			create {XPLAIN_B_REPRESENTATION} yyval17
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp17 >= yyvsc17 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs17")
		end
		yyvsc17 := yyvsc17 + yyInitial_yyvs_size
		yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
	end
	yyspecial_routines17.force (yyvs17, yyval17, yyvsp17)
end
when 153 then
--|#line 1060 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1060")
end

			create {XPLAIN_PK_A_REPRESENTATION} yyval18.make (yyvs3.item (yyvsp3))
			create {XPLAIN_A_REFERENCES} dummya.make
			if attached dummya as r then
				yyval18.set_domain_restriction(sqlgenerator, r)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp18 >= yyvsc18 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs18")
		end
		yyvsc18 := yyvsc18 + yyInitial_yyvs_size
		yyvs18 := yyspecial_routines18.aliased_resized_area (yyvs18, yyvsc18)
	end
	yyspecial_routines18.force (yyvs18, yyval18, yyvsp18)
end
when 154 then
--|#line 1068 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1068")
end

			create {XPLAIN_PK_I_REPRESENTATION} yyval18.make (yyvs3.item (yyvsp3))
			create {XPLAIN_I_REFERENCES} dummyi.make
			if attached dummyi as r then
				yyval18.set_domain_restriction(sqlgenerator, r)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp18 >= yyvsc18 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs18")
		end
		yyvsc18 := yyvsc18 + yyInitial_yyvs_size
		yyvs18 := yyspecial_routines18.aliased_resized_area (yyvs18, yyvsc18)
	end
	yyspecial_routines18.force (yyvs18, yyval18, yyvsp18)
end
when 155 then
--|#line 1076 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1076")
end

			report_error ("type identification expected instead of: " + text)
			abort
			-- silence compiler:
			create {XPLAIN_PK_I_REPRESENTATION}yyval18.make (1)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp18 >= yyvsc18 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs18")
		end
		yyvsc18 := yyvsc18 + yyInitial_yyvs_size
		yyvs18 := yyspecial_routines18.aliased_resized_area (yyvs18, yyvsc18)
	end
	yyspecial_routines18.force (yyvs18, yyval18, yyvsp18)
end
when 156 then
--|#line 1086 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1086")
end

yyval2 := yyvs2.item (yyvsp2); current_type_name := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 157 then
--|#line 1090 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1090")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 158 then
--|#line 1094 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1094")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 159 then
--|#line 1098 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1098")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 160 then
--|#line 1102 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1102")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 161 then
--|#line 1107 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1107")
end

create {XPLAIN_ATTRIBUTE_NODE} yyval19.make (yyvs20.item (yyvsp20), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp19 := yyvsp19 + 1
	yyvsp20 := yyvsp20 -1
	if yyvsp19 >= yyvsc19 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs19")
		end
		yyvsc19 := yyvsc19 + yyInitial_yyvs_size
		yyvs19 := yyspecial_routines19.aliased_resized_area (yyvs19, yyvsc19)
	end
	yyspecial_routines19.force (yyvs19, yyval19, yyvsp19)
end
when 162 then
--|#line 1109 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1109")
end

create {XPLAIN_ATTRIBUTE_NODE} yyval19.make (yyvs20.item (yyvsp20), yyvs19.item (yyvsp19)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp20 := yyvsp20 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines19.force (yyvs19, yyval19, yyvsp19)
end
when 163 then
--|#line 1111 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1111")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 + 1
	yyvsp20 := yyvsp20 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp19 >= yyvsc19 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs19")
		end
		yyvsc19 := yyvsc19 + yyInitial_yyvs_size
		yyvs19 := yyspecial_routines19.aliased_resized_area (yyvs19, yyvsc19)
	end
	yyspecial_routines19.force (yyvs19, yyval19, yyvsp19)
end
when 164 then
--|#line 1118 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1118")
end

create {XPLAIN_ATTRIBUTE} yyval20.make (
			yyvs14.item (yyvsp14).role, yyvs14.item (yyvsp14).abstracttype_if_known,
			True, sqlgenerator.check_if_required (yyvs14.item (yyvsp14).abstracttype_if_known),
			True, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp20 := yyvsp20 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp14 := yyvsp14 -1
	if yyvsp20 >= yyvsc20 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs20")
		end
		yyvsc20 := yyvsc20 + yyInitial_yyvs_size
		yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
	end
	yyspecial_routines20.force (yyvs20, yyval20, yyvsp20)
end
when 165 then
--|#line 1123 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1123")
end

create {XPLAIN_ATTRIBUTE} yyval20.make (
			yyvs14.item (yyvsp14).role, yyvs14.item (yyvsp14).abstracttype_if_known,
			True, sqlgenerator.check_if_required (yyvs14.item (yyvsp14).abstracttype_if_known),
			False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp20 := yyvsp20 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp20 >= yyvsc20 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs20")
		end
		yyvsc20 := yyvsc20 + yyInitial_yyvs_size
		yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
	end
	yyspecial_routines20.force (yyvs20, yyval20, yyvsp20)
end
when 166 then
--|#line 1128 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1128")
end

create {XPLAIN_ATTRIBUTE} yyval20.make (
			yyvs14.item (yyvsp14).role, yyvs14.item (yyvsp14).abstracttype_if_known,
		True, False, False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp20 := yyvsp20 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp20 >= yyvsc20 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs20")
		end
		yyvsc20 := yyvsc20 + yyInitial_yyvs_size
		yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
	end
	yyspecial_routines20.force (yyvs20, yyval20, yyvsp20)
end
when 167 then
--|#line 1132 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1132")
end

create {XPLAIN_ATTRIBUTE} yyval20.make (
			yyvs14.item (yyvsp14).role, yyvs14.item (yyvsp14).abstracttype_if_known,
			True, True, False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp20 := yyvsp20 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp20 >= yyvsc20 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs20")
		end
		yyvsc20 := yyvsc20 + yyInitial_yyvs_size
		yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
	end
	yyspecial_routines20.force (yyvs20, yyval20, yyvsp20)
end
when 168 then
--|#line 1136 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1136")
end

create {XPLAIN_ATTRIBUTE} yyval20.make (
		yyvs14.item (yyvsp14).role, yyvs14.item (yyvsp14).abstracttype_if_known,
		True, True, False, True) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp20 := yyvsp20 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp20 >= yyvsc20 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs20")
		end
		yyvsc20 := yyvsc20 + yyInitial_yyvs_size
		yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
	end
	yyspecial_routines20.force (yyvs20, yyval20, yyvsp20)
end
when 169 then
--|#line 1144 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1144")
end

		create yyval14.make (Void, yyvs2.item (yyvsp2))
		if attached get_known_base_or_type (yyvs2.item (yyvsp2)) as t then
			-- when self reference, it is valid to be Void
			yyval14.set_object (t)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 170 then
--|#line 1152 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1152")
end

		create yyval14.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		if attached get_known_base_or_type (yyvs2.item (yyvsp2)) as t then
			-- when self reference, it is valid to be Void
			yyval14.set_object (t)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 171 then
--|#line 1163 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1163")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 172 then
--|#line 1165 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1165")
end

yyval2  := yyvs2.item (yyvsp2 - 1) + " " + yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 173 then
--|#line 1169 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1169")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 174 then
--|#line 1173 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1173")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines3.force (yyvs3, yyval3, yyvsp3)
end
when 175 then
--|#line 1180 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1180")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 176 then
--|#line 1190 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1190")
end

yyval10 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 177 then
--|#line 1195 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1195")
end

			if attached {XPLAIN_LOGICAL_EXPRESSION} yyvs10.item (yyvsp10) as dummyl then
				yyval9 := dummyl
			else
				create yyval9.make (yyvs10.item (yyvsp10))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs9")
		end
		yyvsc9 := yyvsc9 + yyInitial_yyvs_size
		yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
	end
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
when 178 then
--|#line 1203 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1203")
end

			yyval9 := new_logical_expression (yyvs10.item (yyvsp10), once "or", yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
when 179 then
--|#line 1210 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1210")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 180 then
--|#line 1212 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1212")
end

create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), "and", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 181 then
--|#line 1217 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1217")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 182 then
--|#line 1219 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1219")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs9.item (yyvsp9))
		  create {XPLAIN_NOT_EXPRESSION} yyval10.make (yyval10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 183 then
--|#line 1222 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1222")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 184 then
--|#line 1224 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1224")
end

		yyval10 := silence_compiler_logical_expression
		-- @@BdB: This seems tricky: I shouldn't be able to assign a
		-- variable to a constant. And it looks like that isn't
		-- forbidden in the following code:
		if attached universe.find_variable (yyvs2.item (yyvsp2)) as variable then
			create {XPLAIN_VARIABLE_EXPRESSION} dummye.make (variable)
			if attached dummye as e then
				create {XPLAIN_NOT_EXPRESSION} yyval10.make (e)
			end
		elseif attached universe.find_value (yyvs2.item (yyvsp2)) as value then
			-- not a variable, maybe a value?
			-- depends on context, not checked now
			create {XPLAIN_VALUE_EXPRESSION} dummye.make (value)
			if attached dummye as e then
				create {XPLAIN_NOT_EXPRESSION} yyval10.make (e)
			end
		else
			report_error ("Not a known variable: " + yyvs2.item (yyvsp2))
			abort
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 185 then
--|#line 1247 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1247")
end

create {XPLAIN_STRING_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 186 then
--|#line 1249 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1249")
end

yyval10 := yyvs11.item (yyvsp11) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp11 := yyvsp11 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 187 then
--|#line 1251 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1251")
end

create {XPLAIN_NOT_EXPRESSION} yyval10.make (yyvs11.item (yyvsp11)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp11 := yyvsp11 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 188 then
--|#line 1253 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1253")
end

			create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 189 then
--|#line 1262 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1262")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), "+", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 190 then
--|#line 1264 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1264")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), "-", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 191 then
--|#line 1266 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1266")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 192 then
--|#line 1271 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1271")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), "*", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 193 then
--|#line 1273 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1273")
end

create {XPLAIN_INFIX_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10 - 1), "/", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 194 then
--|#line 1275 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1275")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 195 then
--|#line 1280 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1280")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval10.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 196 then
--|#line 1282 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1282")
end

create {XPLAIN_NUMBER_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 197 then
--|#line 1284 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1284")
end

create {XPLAIN_PREFIX_EXPRESSION} yyval10.make ("-", yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 198 then
--|#line 1286 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1286")
end

			if attached universe.find_variable (yyvs2.item (yyvsp2)) as variable then
				create {XPLAIN_VARIABLE_EXPRESSION} yyval10.make (variable)
			elseif attached universe.find_value (yyvs2.item (yyvsp2)) as value then
				if not constant_mode then
					-- not a variable, maybe a value?
					-- depends on context, not checked now
					create {XPLAIN_VALUE_EXPRESSION} yyval10.make (value)
				else
					report_error ("A constant expression can only use constant, not a variable: " + yyvs2.item (yyvsp2))
					abort
					yyval10 := silence_compiler_expression
				end
			else
				report_error ("Not a known constant or variable: " + yyvs2.item (yyvsp2))
				abort
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 199 then
--|#line 1306 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1306")
end

			if is_parameter_declared (yyvs14.item (yyvsp14)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14))
			else
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 200 then
--|#line 1315 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1315")
end

			create {XPLAIN_NEWDATE_FUNCTION} yyval10.make (yyvs10.item (yyvsp10 - 1), yyvs10.item (yyvsp10), newdate_default_days)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp10 := yyvsp10 -1
	yyvsp1 := yyvsp1 -3
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 201 then
--|#line 1319 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1319")
end

			create {XPLAIN_NEWDATE_FUNCTION} yyval10.make (yyvs10.item (yyvsp10 - 2), yyvs10.item (yyvsp10 - 1), yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp10 := yyvsp10 -2
	yyvsp1 := yyvsp1 -4
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 202 then
--|#line 1333 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1333")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp5 := yyvsp5 + 1
	if yyvsp5 >= yyvsc5 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs5")
		end
		yyvsc5 := yyvsc5 + yyInitial_yyvs_size
		yyvs5 := yyspecial_routines5.aliased_resized_area (yyvs5, yyvsc5)
	end
	yyspecial_routines5.force (yyvs5, yyval5, yyvsp5)
end
when 203 then
--|#line 1334 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1334")
end

yyval5 := yyvs6.item (yyvsp6) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp5 >= yyvsc5 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs5")
		end
		yyvsc5 := yyvsc5 + yyInitial_yyvs_size
		yyvs5 := yyspecial_routines5.aliased_resized_area (yyvs5, yyvsc5)
	end
	yyspecial_routines5.force (yyvs5, yyval5, yyvsp5)
end
when 204 then
--|#line 1337 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1337")
end

			if attached extend_type as et and attached yyvs30.item (yyvsp30) as ed then
				create {XPLAIN_ASSERTION} yyval21.make (sqlgenerator, et, yyvs2.item (yyvsp2), yyvs5.item (yyvsp5), ed)
				if immediate_output_mode and then
					(yyval21.is_function or else yyval21.is_complex or else not sqlgenerator.CalculatedColumnsSupported) then
					write_pending_statement
					sqlgenerator.write_assertion (yyval21)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -1
	yyvsp30 := yyvsp30 -1
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
when 205 then
--|#line 1337 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1337")
end

			extend_type := get_known_type (yyvs2.item (yyvsp2))
			subject_type := extend_type            -- in case of expression extension
			last_width := 1 -- hack, incorrect restriction for assert, must base * on max width of expression
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp21 := yyvsp21 + 1
	if yyvsp21 >= yyvsc21 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs21")
		end
		yyvsc21 := yyvsc21 + yyInitial_yyvs_size
		yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
	end
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
when 206 then
--|#line 1354 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1354")
end

			report_error ("Please use its instead of with.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp21 := yyvsp21 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp21 >= yyvsc21 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs21")
		end
		yyvsc21 := yyvsc21 + yyInitial_yyvs_size
		yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
	end
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
when 207 then
--|#line 1359 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1359")
end

			report_warning ("Virtual value assertion not yet supported. No code will be generated.")
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp21 := yyvsp21 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp6 := yyvsp6 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp21 >= yyvsc21 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs21")
		end
		yyvsc21 := yyvsc21 + yyInitial_yyvs_size
		yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
	end
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
when 208 then
--|#line 1365 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1365")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
when 209 then
--|#line 1369 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1369")
end

yyval1 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 210 then
--|#line 1373 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1373")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 211 then
--|#line 1377 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1377")
end

		if attached subject_type as st and attached yyvs22.item (yyvsp22) as al then
			create myindex.make (st, yyvs2.item (yyvsp2), False, False, al)
			if not use_mode and then attached myindex as index then
				sqlgenerator.write_index (index)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	yyvsp22 := yyvsp22 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 212 then
--|#line 1377 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1377")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 213 then
--|#line 1391 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1391")
end

		if attached subject_type as st and attached yyvs22.item (yyvsp22) as al then
			create myindex.make (st, yyvs2.item (yyvsp2), True, False, al)
			if not use_mode and then attached myindex as index then
				sqlgenerator.write_index (index)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -2
	yyvsp22 := yyvsp22 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 214 then
--|#line 1391 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1391")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 215 then
--|#line 1404 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1404")
end

		if attached subject_type as st and attached yyvs22.item (yyvsp22) as al then
			create myindex.make (st, yyvs2.item (yyvsp2), False, True, al)
			if not use_mode and then attached myindex as index then
				sqlgenerator.write_index (index)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -2
	yyvsp22 := yyvsp22 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 216 then
--|#line 1404 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1404")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 217 then
--|#line 1417 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1417")
end

		if attached subject_type as st and attached yyvs22.item (yyvsp22) as al then
			create myindex.make (st, yyvs2.item (yyvsp2), True, True, al)
			if not use_mode and then attached myindex as index then
				sqlgenerator.write_index (index)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp1 := yyvsp1 -5
	yyvsp2 := yyvsp2 -2
	yyvsp22 := yyvsp22 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 218 then
--|#line 1417 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1417")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 219 then
--|#line 1433 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1433")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp22 := yyvsp22 + 1
	if yyvsp22 >= yyvsc22 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs22")
		end
		yyvsc22 := yyvsc22 + yyInitial_yyvs_size
		yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
	end
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 220 then
--|#line 1434 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1434")
end

yyval22 := yyvs22.item (yyvsp22) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 221 then
--|#line 1438 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1438")
end

			check attached subject_type as t then
				if attached t.find_attribute (yyvs14.item (yyvsp14)) then
					create yyval22.make (yyvs14.item (yyvsp14), Void)
				else
					error_unknown_attribute (t.name, yyvs14.item (yyvsp14))
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp22 := yyvsp22 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp22 >= yyvsc22 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs22")
		end
		yyvsc22 := yyvsc22 + yyInitial_yyvs_size
		yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
	end
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 222 then
--|#line 1448 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1448")
end

			check attached subject_type as t then
				if attached t.find_attribute (yyvs14.item (yyvsp14)) then
					create yyval22.make (yyvs14.item (yyvsp14), yyvs22.item (yyvsp22))
				else
					error_unknown_attribute (t.name, yyvs14.item (yyvsp14))
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 223 then
--|#line 1458 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1458")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp22 := yyvsp22 + 1
	yyvsp14 := yyvsp14 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp22 >= yyvsc22 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs22")
		end
		yyvsc22 := yyvsc22 + yyInitial_yyvs_size
		yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
	end
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 224 then
--|#line 1473 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1473")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 225 then
--|#line 1475 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1475")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 226 then
--|#line 1480 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1480")
end

yyval38 := yyvs48.item (yyvsp48) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp48 := yyvsp48 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 227 then
--|#line 1482 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1482")
end

yyval38 := yyvs43.item (yyvsp43) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp43 := yyvsp43 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 228 then
--|#line 1484 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1484")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 229 then
--|#line 1486 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1486")
end

yyval38 := yyvs41.item (yyvsp41) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp41 := yyvsp41 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 230 then
--|#line 1491 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1491")
end

			write_pending_statement
			if attached yyvs25.item (yyvsp25) as subject and then attached subject.type as mytype and then attached yyvs23.item (yyvsp23) as al then
				warn_attributes_with_inits (al)
				if not attached subject.identification as identification then
					report_error ("Identification expected.")
					abort
				elseif
					mytype.representation.is_integer and then
					identification.is_constant and then
					not identification.sqlvalue (sqlgenerator).is_integer then
					report_error (format ("Primary key %"$s%" is not an integer.", <<identification.sqlvalue (sqlgenerator)>>))
					abort
				else
					create {XPLAIN_INSERT_STATEMENT} yyval38.make (mytype, identification, al)
					if immediate_output_mode then
						sqlgenerator.write_insert (mytype, identification, al)
					end
				end
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp25 := yyvsp25 -1
	yyvsp23 := yyvsp23 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 231 then
--|#line 1514 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1514")
end

			write_pending_statement
			if attached yyvs25.item (yyvsp25) as subject and then attached subject.type as mytype then
				if not sqlgenerator.CreateAutoPrimaryKey
				then
					-- Can't abort as it might be output for a dialect that
					-- doesn't support auto primary keys.
					report_warning ("auto primary key support disabled, but insert with '*' as primary key specified.")
				elseif
					not mytype.representation.is_integer
				then
					report_error ("Auto-primary keys on character instance identification not supported.")
					abort
				end
				if attached mytype as t and attached yyvs23.item (yyvsp23) as al then
					create {XPLAIN_INSERT_STATEMENT} yyval38.make (t, Void, al)
					if immediate_output_mode then
						sqlgenerator.write_insert (t, Void, al)
					end
				end
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp25 := yyvsp25 -1
	yyvsp23 := yyvsp23 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 232 then
--|#line 1538 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1538")
end

			report_error ("its expected instead of: '" + text + "'")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp25 := yyvsp25 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 233 then
--|#line 1543 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1543")
end

			write_pending_statement
			if attached yyvs32.item (yyvsp32) as swsf and attached yyvs25.item (yyvsp25) as subject then
				create {XPLAIN_GET_INSERT_STATEMENT} yyval38.make (swsf, subject.type, False, yyvs22.item (yyvsp22))
				if immediate_output_mode then
					yyval38.write (sqlgenerator)
				end
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp32 := yyvsp32 -1
	yyvsp25 := yyvsp25 -1
	yyvsp22 := yyvsp22 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 234 then
--|#line 1554 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1554")
end

			write_pending_statement
			if attached yyvs32.item (yyvsp32) as swsf and attached yyvs25.item (yyvsp25) as subject then
				if not sqlgenerator.CreateAutoPrimaryKey then
					-- Can't abort as it might be output for a dialect that
					-- doesn't support auto primary keys.
					report_warning ("auto primary key support disabled, but insert with '*' as primary key specified.")
				elseif not subject.type.representation.is_integer
				then
					report_error ("Auto-primary keys on character instance identification not supported.")
					abort
				end
				create {XPLAIN_GET_INSERT_STATEMENT} yyval38.make (swsf, subject.type, True, yyvs22.item (yyvsp22))
				if immediate_output_mode then
					yyval38.write (sqlgenerator)
				end
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp32 := yyvsp32 -1
	yyvsp25 := yyvsp25 -1
	yyvsp22 := yyvsp22 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 235 then
--|#line 1577 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1577")
end

create {XPLAIN_ASSIGNMENT_NODE} yyval23.make (yyvs24.item (yyvsp24), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp23 := yyvsp23 + 1
	yyvsp24 := yyvsp24 -1
	if yyvsp23 >= yyvsc23 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs23")
		end
		yyvsc23 := yyvsc23 + yyInitial_yyvs_size
		yyvs23 := yyspecial_routines23.aliased_resized_area (yyvs23, yyvsc23)
	end
	yyspecial_routines23.force (yyvs23, yyval23, yyvsp23)
end
when 236 then
--|#line 1579 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1579")
end

create {XPLAIN_ASSIGNMENT_NODE} yyval23.make (yyvs24.item (yyvsp24), yyvs23.item (yyvsp23)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp24 := yyvsp24 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines23.force (yyvs23, yyval23, yyvsp23)
end
when 237 then
--|#line 1581 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1581")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp23 := yyvsp23 + 1
	yyvsp24 := yyvsp24 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp23 >= yyvsc23 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs23")
		end
		yyvsc23 := yyvsc23 + yyInitial_yyvs_size
		yyvs23 := yyspecial_routines23.aliased_resized_area (yyvs23, yyvsc23)
	end
	yyspecial_routines23.force (yyvs23, yyval23, yyvsp23)
end
when 238 then
--|#line 1589 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1589")
end

create {XPLAIN_ASSIGNMENT} yyval24.make (yyvs14.item (yyvsp14), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp24 := yyvsp24 + 1
	yyvsp14 := yyvsp14 -1
	yyvsp1 := yyvsp1 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp24 >= yyvsc24 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs24")
		end
		yyvsc24 := yyvsc24 + yyInitial_yyvs_size
		yyvs24 := yyspecial_routines24.aliased_resized_area (yyvs24, yyvsc24)
	end
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
when 239 then
--|#line 1594 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1594")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 240 then
--|#line 1596 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1596")
end

yyval10 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 241 then
--|#line 1601 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1601")
end

			if yyvs42.item (yyvsp42) /= Void then
				if attached get_known_type (yyvs2.item (yyvsp2)) as st and then attached yyvs42.item (yyvsp42) as cd then -- subject_type changed by cascade_definition I think
					create yyval41.make (sqlgenerator, st, yyvs14.item (yyvsp14), cd)
					if immediate_output_mode then
						yyval41.write (sqlgenerator)
					end
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp14 := yyvsp14 -1
	yyvsp42 := yyvsp42 -1
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
when 242 then
--|#line 1601 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1601")
end

			subject_type := get_known_type (yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp41 := yyvsp41 + 1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
when 243 then
--|#line 1624 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1624")
end

			if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and attached yyvs27.item (yyvsp27) as sf then
				create {XPLAIN_CASCADE_FUNCTION_EXPRESSION} yyval42.make (sf, yyvs13.item (yyvsp13))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp42 := yyvsp42 + 1
	yyvsp27 := yyvsp27 -1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp42 >= yyvsc42 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs42")
		end
		yyvsc42 := yyvsc42 + yyInitial_yyvs_size
		yyvs42 := yyspecial_routines42.aliased_resized_area (yyvs42, yyvsc42)
	end
	yyspecial_routines42.force (yyvs42, yyval42, yyvsp42)
end
when 244 then
--|#line 1630 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1630")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp42 := yyvsp42 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp42 >= yyvsc42 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs42")
		end
		yyvsc42 := yyvsc42 + yyInitial_yyvs_size
		yyvs42 := yyspecial_routines42.aliased_resized_area (yyvs42, yyvsc42)
	end
	yyspecial_routines42.force (yyvs42, yyval42, yyvsp42)
end
when 245 then
--|#line 1631 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1631")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp42 := yyvsp42 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp42 >= yyvsc42 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs42")
		end
		yyvsc42 := yyvsc42 + yyInitial_yyvs_size
		yyvs42 := yyspecial_routines42.aliased_resized_area (yyvs42, yyvsc42)
	end
	yyspecial_routines42.force (yyvs42, yyval42, yyvsp42)
end
when 246 then
--|#line 1637 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1637")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
when 247 then
--|#line 1641 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1641")
end

			write_pending_statement
			if attached yyvs25.item (yyvsp25) as s then
				if immediate_output_mode then
					sqlgenerator.write_delete (s, yyvs16.item (yyvsp16))
				end
				create yyval43.make (s, yyvs16.item (yyvsp16))
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp43 := yyvsp43 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp25 := yyvsp25 -1
	yyvsp16 := yyvsp16 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
when 248 then
--|#line 1655 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1655")
end

			if attached get_known_type (yyvs2.item (yyvsp2)) as t then
				subject_type := t
				if attached {XPLAIN_STRING_EXPRESSION} yyvs16.item (yyvsp16) as my_str and then t.representation.length < my_str.value.count then
					report_error ("Instance identification %"" + my_str.value + "%" does not fit in domain " + t.representation.domain + " of type " + t.name + ".")
					abort
				else
					create {XPLAIN_SUBJECT} yyval25.make (t, yyvs16.item (yyvsp16))
				end
			else
				report_error ("Type `" + yyvs2.item (yyvsp2) + "' not known.")
				abort
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp16 := yyvsp16 -1
	if yyvsp25 >= yyvsc25 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs25")
		end
		yyvsc25 := yyvsc25 + yyInitial_yyvs_size
		yyvs25 := yyspecial_routines25.aliased_resized_area (yyvs25, yyvsc25)
	end
	yyspecial_routines25.force (yyvs25, yyval25, yyvsp25)
end
when 249 then
--|#line 1673 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1673")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp16 := yyvsp16 + 1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 250 then
--|#line 1674 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1674")
end

			-- number or string
			if yyvs2.item (yyvsp2).is_integer then
				create {XPLAIN_NUMBER_EXPRESSION} yyval16.make (yyvs2.item (yyvsp2))
			else
				create {XPLAIN_STRING_EXPRESSION} yyval16.make (yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 251 then
--|#line 1683 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1683")
end

			if is_parameter_declared (yyvs14.item (yyvsp14)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval16.make (yyvs14.item (yyvsp14))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 252 then
--|#line 1689 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1689")
end

			if attached get_known_value (yyvs2.item (yyvsp2)) as value then
				create {XPLAIN_VALUE_EXPRESSION} yyval16.make (value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 253 then
--|#line 1695 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1695")
end

			report_error ("name of a value expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 254 then
--|#line 1703 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1703")
end

		write_pending_statement
		if attached yyvs23.item (yyvsp23) as al and attached yyvs25.item (yyvsp25) as s then
			if immediate_output_mode then
				sqlgenerator.write_update (s, al, yyvs16.item (yyvsp16))
			end
			subject_type := Void
			create yyval48.make (s, al, yyvs16.item (yyvsp16))
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp48 := yyvsp48 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp25 := yyvsp25 -1
	yyvsp23 := yyvsp23 -1
	yyvsp16 := yyvsp16 -1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
when 255 then
--|#line 1714 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1714")
end

report_error ("its expected instead of: '" + text + "'")
		  abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp48 := yyvsp48 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp25 := yyvsp25 -1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
when 256 then
--|#line 1719 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1719")
end

		create {XPLAIN_ATTRIBUTE_NAME} yyval14.make (Void, yyvs2.item (yyvsp2))
		if attached subject_type as t then
			if attached t.find_attribute (yyval14) as myattribute then
				yyval14.set_attribute (myattribute)
			else
				error_unknown_attribute (t.name, yyval14)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 257 then
--|#line 1730 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1730")
end

		create {XPLAIN_ATTRIBUTE_NAME} yyval14.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		if attached subject_type as t then
			if attached t.find_attribute (yyval14) as myattribute then
				yyval14.set_attribute (myattribute)
			else
				error_unknown_attribute (t.name, yyval14)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp14 >= yyvsc14 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs14")
		end
		yyvsc14 := yyvsc14 + yyInitial_yyvs_size
		yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
	end
	yyspecial_routines14.force (yyvs14, yyval14, yyvsp14)
end
when 258 then
--|#line 1743 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1743")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp45 := yyvsp45 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 259 then
--|#line 1744 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1744")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 260 then
--|#line 1745 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1745")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp49 := yyvsp49 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 261 then
--|#line 1746 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1746")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 262 then
--|#line 1748 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1748")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp50 := yyvsp50 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 263 then
--|#line 1752 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1752")
end

			write_pending_statement
			yyval49 := new_value_statement (sqlgenerator, yyvs2.item (yyvsp2), yyvs10.item (yyvsp10))
			if immediate_output_mode then
				sqlgenerator.write_value (yyval49.value)
			end
			universe.add (yyval49.value, Current)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp49 := yyvsp49 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
when 264 then
--|#line 1764 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1764")
end

yyval10 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 265 then
--|#line 1766 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1766")
end

			if attached yyvs27.item (yyvsp27) as e then
				create {XPLAIN_SELECTION_EXPRESSION} yyval10.make (e)
			else
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp27 := yyvsp27 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 266 then
--|#line 1774 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1774")
end

			if not sqlgenerator.CreateAutoPrimaryKey then
				report_error ("Auto primary key support disabled or not supported. Cannot retrieve auto-generated primary key.")
			end
			if attached get_known_type (yyvs2.item (yyvsp2)) as mytype then
				create {XPLAIN_LAST_AUTO_PK_EXPRESSION} yyval10.make (mytype)
			else
				yyval10 := silence_compiler_expression
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 267 then
--|#line 1785 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1785")
end

yyval10 := silence_compiler_expression 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp26 := yyvsp26 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 268 then
--|#line 1787 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1787")
end

create {XPLAIN_UNMANAGED_PARAMETER_EXPRESSION} yyval10.make (yyvs14.item (yyvsp14).full_name) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 269 then
--|#line 1789 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1789")
end

yyval10 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 270 then
--|#line 1793 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1793")
end

			create {XPLAIN_DATEF_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 271 then
--|#line 1797 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1797")
end

			create {XPLAIN_INTEGER_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 272 then
--|#line 1801 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1801")
end

			create {XPLAIN_REAL_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 273 then
--|#line 1805 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1805")
end

			create {XPLAIN_STRING_FUNCTION} yyval10.make (yyvs10.item (yyvsp10))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 274 then
--|#line 1811 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1811")
end

			create {XPLAIN_USER_FUNCTION} yyval10.make (yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 275 then
--|#line 1815 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1815")
end

			create {XPLAIN_USER_FUNCTION} yyval10.make (yyvs2.item (yyvsp2), yyvs35.item (yyvsp35))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp35 := yyvsp35 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 276 then
--|#line 1820 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1820")
end

create {XPLAIN_SQL_EXPRESSION} yyval10.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp10 >= yyvsc10 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs10")
		end
		yyvsc10 := yyvsc10 + yyInitial_yyvs_size
		yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
	end
	yyspecial_routines10.force (yyvs10, yyval10, yyvsp10)
end
when 277 then
--|#line 1825 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1825")
end

			write_pending_statement
			if attached get_known_value (yyvs2.item (yyvsp2)) as value then
				if immediate_output_mode then
					sqlgenerator.write_select_value (value)
				end
				create yyval50.make (value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
when 278 then
--|#line 1838 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1838")
end

			report_error ("Input not yet supported.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
when 279 then
--|#line 1843 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1843")
end

			report_error ("Input not yet supported.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp17 := yyvsp17 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
when 280 then
--|#line 1851 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1851")
end

			if yyvs34.item (yyvsp34).property_required = 0 and attached yyvs16.item (yyvsp16 - 1) then
				report_error ("Function " + yyvs34.item (yyvsp34).name + " does not allow a property to be present.")
				abort
			elseif yyvs34.item (yyvsp34).property_required = 1 and not attached yyvs16.item (yyvsp16 - 1) then
				report_error ("Function " + yyvs34.item (yyvsp34).name + " requires the presence of a property.")
				abort
			elseif attached yyvs25.item (yyvsp25) as s then
				create yyval27.make (yyvs34.item (yyvsp34), s, yyvs16.item (yyvsp16 - 1), yyvs16.item (yyvsp16))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp27 := yyvsp27 + 1
	yyvsp34 := yyvsp34 -1
	yyvsp25 := yyvsp25 -1
	yyvsp16 := yyvsp16 -2
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
when 281 then
--|#line 1867 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1867")
end

		if attached yyvs31.item (yyvsp31) as se then
			create {XPLAIN_GET_STATEMENT} yyval45.make (se)
			write_pending_statement
			if immediate_output_mode then
				sqlgenerator.write_select (se)
			end
		end
		subject_type := Void
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp45 >= yyvsc45 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs45")
		end
		yyvsc45 := yyvsc45 + yyInitial_yyvs_size
		yyvs45 := yyspecial_routines45.aliased_resized_area (yyvs45, yyvsc45)
	end
	yyspecial_routines45.force (yyvs45, yyval45, yyvsp45)
end
when 282 then
--|#line 1881 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1881")
end

			if attached yyvs28.item (yyvsp28) as ee then
				if immediate_output_mode then
					sqlgenerator.write_extend (ee)
				end
				create yyval44.make (ee)
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp44 := yyvsp44 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
when 283 then
--|#line 1894 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1894")
end

			if attached extend_type as et and attached yyvs30.item (yyvsp30) as ed then
				if et.has_attribute (Void, yyvs29.item (yyvsp29).name) then
					report_error (format ("Cannot extend type `$s' with attribute `$s', because it already has an attribute with that name.", <<yyvs2.item (yyvsp2), yyvs29.item (yyvsp29).name>>))
					abort
				elseif universe.has (yyvs29.item (yyvsp29).name) then
					report_error (format ("There is already an object (constant, value, base, type or procedure) with name `$s'. The name of an extend must be unique to avoid ambiguous expressions.", <<yyvs29.item (yyvsp29).name>>))
					abort
				else
					create yyval28.make (sqlgenerator, et, yyvs29.item (yyvsp29), ed)
					--extend_type.add_extension ($$)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp29 := yyvsp29 -1
	yyvsp30 := yyvsp30 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
when 284 then
--|#line 1894 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1894")
end

			write_pending_statement
			extend_type := get_known_type (yyvs2.item (yyvsp2))
			subject_type := extend_type -- in case of expression extension
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp28 := yyvsp28 + 1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
when 285 then
--|#line 1915 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1915")
end

			report_error ("Use with instead of its in the extend expression.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
when 286 then
--|#line 1923 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1923")
end

create yyval29.make (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
when 287 then
--|#line 1925 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1925")
end

create yyval29.make (yyvs2.item (yyvsp2), yyvs17.item (yyvsp17)); yyvs17.item (yyvsp17).set_domain_restriction (sqlgenerator, dummyrestriction) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp29 := yyvsp29 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
when 288 then
--|#line 1930 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1930")
end

create {XPLAIN_EXTENSION_EXPRESSION_EXPRESSION} yyval30.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
when 289 then
--|#line 1932 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1932")
end

create {XPLAIN_EXTENSION_EXPRESSION_EXPRESSION} yyval30.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp9 := yyvsp9 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
when 290 then
--|#line 1934 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1934")
end

-- check per attribute tree for validness
		if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) and attached yyvs27.item (yyvsp27) as sf and then attached yyvs13.item (yyvsp13).last as last then
			if last.item.object = extend_type then
				create {XPLAIN_EXTENSION_FUNCTION_EXPRESSION} yyval30.make (sf, yyvs13.item (yyvsp13))
			else
				check attached last.item.object as object and attached extend_type as et then
					report_error ("Error in per clause. The given type is `" + object.name + "', while the expected type is `" + et.name + "'. Make sure the per property ends in the same type that is being extended.")
				end
				abort
			end

-- 			mytype ?= $3.last.item.object
-- 			if mytype /= Void then
-- 				create {XPLAIN_EXTENSION_FUNCTION_EXPRESSION} $$.make ($1, $3)
-- 			else
-- 				report_error ("Per property must be a type, cannot be a base.")
-- 				abort
-- 			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp30 := yyvsp30 + 1
	yyvsp27 := yyvsp27 -1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
when 291 then
--|#line 1955 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1955")
end

			report_error("per keyword expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp30 := yyvsp30 + 1
	yyvsp27 := yyvsp27 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
when 292 then
--|#line 1963 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1963")
end

yyval31 := yyvs32.item (yyvsp32) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp31 := yyvsp31 + 1
	yyvsp32 := yyvsp32 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
when 293 then
--|#line 1965 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1965")
end

yyval31 := yyvs27.item (yyvsp27) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp31 := yyvsp31 + 1
	yyvsp27 := yyvsp27 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
when 294 then
--|#line 1970 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1970")
end

			if attached yyvs25.item (yyvsp25) as s then
				create {XPLAIN_SELECTION_LIST} yyval32.make (s, yyvs35.item (yyvsp35), yyvs16.item (yyvsp16), yyvs33.item (yyvsp33))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp32 := yyvsp32 + 1
	yyvsp25 := yyvsp25 -1
	yyvsp35 := yyvsp35 -1
	yyvsp16 := yyvsp16 -1
	yyvsp33 := yyvsp33 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
when 295 then
--|#line 1976 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1976")
end

			if attached yyvs25.item (yyvsp25) as s then
				create {XPLAIN_SELECTION_LIST} yyval32.make (s, yyvs35.item (yyvsp35), yyvs16.item (yyvsp16), yyvs33.item (yyvsp33))
				yyval32.set_identification_text (yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp32 := yyvsp32 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp25 := yyvsp25 -1
	yyvsp35 := yyvsp35 -1
	yyvsp16 := yyvsp16 -1
	yyvsp33 := yyvsp33 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
when 296 then
--|#line 1985 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1985")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp33 := yyvsp33 + 1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 297 then
--|#line 1986 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1986")
end

yyval33 := yyvs33.item (yyvsp33) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 298 then
--|#line 1991 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1991")
end

			if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) then
				create {XPLAIN_SORT_NODE} yyval33.make (yyvs13.item (yyvsp13), True, Void)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 299 then
--|#line 1997 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1997")
end

			if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) then
				create {XPLAIN_SORT_NODE} yyval33.make (yyvs13.item (yyvsp13), False, Void)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 300 then
--|#line 2003 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2003")
end

			if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) then
				create {XPLAIN_SORT_NODE} yyval33.make (yyvs13.item (yyvsp13), True, yyvs33.item (yyvsp33))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 301 then
--|#line 2009 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2009")
end

			if attached get_object_if_valid_tree (yyvs13.item (yyvsp13)) then
				create {XPLAIN_SORT_NODE} yyval33.make (yyvs13.item (yyvsp13), False, yyvs33.item (yyvsp33))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp13 := yyvsp13 -1
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
when 302 then
--|#line 2018 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2018")
end

			if yyvs34.item (yyvsp34).property_required = 0 and attached yyvs16.item (yyvsp16 - 1) then
				report_error ("Function " + yyvs34.item (yyvsp34).name + " does not allow a property to be present.")
				abort
			elseif yyvs34.item (yyvsp34).property_required = 1 and not attached yyvs16.item (yyvsp16 - 1) then
				report_error ("Function " + yyvs34.item (yyvsp34).name + " requires the presence of a property.")
				abort
			elseif attached yyvs25.item (yyvsp25) as s then
				create yyval27.make (yyvs34.item (yyvsp34), s, yyvs16.item (yyvsp16 - 1), yyvs16.item (yyvsp16))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp27 := yyvsp27 + 1
	yyvsp34 := yyvsp34 -1
	yyvsp25 := yyvsp25 -1
	yyvsp16 := yyvsp16 -2
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
when 303 then
--|#line 2032 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2032")
end

create {XPLAIN_MAX_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 304 then
--|#line 2034 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2034")
end

create {XPLAIN_MIN_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 305 then
--|#line 2036 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2036")
end

create {XPLAIN_TOTAL_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 306 then
--|#line 2038 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2038")
end

create {XPLAIN_COUNT_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 307 then
--|#line 2040 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2040")
end

create {XPLAIN_ANY_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 308 then
--|#line 2042 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2042")
end

create {XPLAIN_NIL_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 309 then
--|#line 2044 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2044")
end

create {XPLAIN_SOME_FUNCTION} yyval34 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
when 310 then
--|#line 2055 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2055")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp35 := yyvsp35 + 1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 311 then
--|#line 2056 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2056")
end

			if attached yyvs35.item (yyvsp35) as property_list then
				yyval35 := property_list
				property_list.give_column_names (2) -- first column is always the instance id
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 312 then
--|#line 2066 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2066")
end

create yyval35.make (yyvs10.item (yyvsp10), yyvs36.item (yyvsp36), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp35 := yyvsp35 + 1
	yyvsp10 := yyvsp10 -1
	yyvsp36 := yyvsp36 -1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 313 then
--|#line 2068 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2068")
end

create yyval35.make (yyvs10.item (yyvsp10), yyvs36.item (yyvsp36), yyvs35.item (yyvsp35)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp10 := yyvsp10 -1
	yyvsp36 := yyvsp36 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 314 then
--|#line 2070 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2070")
end

			report_error ("its keyword should not appear after comma. Remove it.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp35 := yyvsp35 + 1
	yyvsp10 := yyvsp10 -1
	yyvsp36 := yyvsp36 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 315 then
--|#line 2075 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2075")
end

			report_error ("Superfluous comma detected. Remove it.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp35 := yyvsp35 + 1
	yyvsp10 := yyvsp10 -1
	yyvsp36 := yyvsp36 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
when 316 then
--|#line 2083 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2083")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp16 := yyvsp16 + 1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 317 then
--|#line 2084 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2084")
end

yyval16 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 318 then
--|#line 2089 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2089")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
when 319 then
--|#line 2090 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2090")
end

yyval36 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp36 := yyvsp36 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
when 320 then
--|#line 2092 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2092")
end

			report_error ("The as keyword should be followed by a name (my name) or a quoted name (`my new name'), not by a string.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp36 := yyvsp36 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
when 321 then
--|#line 2100 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2100")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp16 := yyvsp16 + 1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 322 then
--|#line 2101 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2101")
end

yyval16 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp16 >= yyvsc16 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs16")
		end
		yyvsc16 := yyvsc16 + yyInitial_yyvs_size
		yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
	end
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
when 323 then
--|#line 2106 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2106")
end

		if not use_mode then
			sqlgenerator.echo(yyvs2.item (yyvsp2))
			sqlgenerator.write_echo(yyvs2.item (yyvsp2))
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
when 324 then
--|#line 2121 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2121")
end

			procedure_mode := False
			yyval46 := new_procedure_statement (yyvs2.item (yyvsp2), yyvs22.item (yyvsp22), yyvs3.item (yyvsp3), yyvs37.item (yyvsp37))
			if not yyvs47.item (yyvsp47).sql.is_empty then
				yyval46.procedure.sql_declare.append_string (yyvs47.item (yyvsp47).sql)
			end
			universe.add (yyval46.procedure, Current)
			if immediate_output_mode then
				sqlgenerator.write_procedure (yyval46.procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp46 := yyvsp46 -1
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp22 := yyvsp22 -1
	yyvsp47 := yyvsp47 -1
	yyvsp1 := yyvsp1 -2
	yyvsp37 := yyvsp37 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
when 325 then
--|#line 2121 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2121")
end

			write_pending_statement
			procedure_mode := True
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
when 326 then
--|#line 2121 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2121")
end

			my_parameters := yyvs22.item (yyvsp22)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
when 327 then
--|#line 2145 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2145")
end

yyval3 := 0 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs3")
		end
		yyvsc3 := yyvsc3 + yyInitial_yyvs_size
		yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
	end
	yyspecial_routines3.force (yyvs3, yyval3, yyvsp3)
end
when 328 then
--|#line 2146 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2146")
end

yyval3 := 1 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs3")
		end
		yyvsc3 := yyvsc3 + yyInitial_yyvs_size
		yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
	end
	yyspecial_routines3.force (yyvs3, yyval3, yyvsp3)
end
when 329 then
--|#line 2147 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2147")
end

yyval3 := 2 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs3")
		end
		yyvsc3 := yyvsc3 + yyInitial_yyvs_size
		yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
	end
	yyspecial_routines3.force (yyvs3, yyval3, yyvsp3)
end
when 330 then
--|#line 2148 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2148")
end

yyval3 := 3 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs3")
		end
		yyvsc3 := yyvsc3 + yyInitial_yyvs_size
		yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
	end
	yyspecial_routines3.force (yyvs3, yyval3, yyvsp3)
end
when 331 then
--|#line 2152 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2152")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp22 := yyvsp22 + 1
	if yyvsp22 >= yyvsc22 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs22")
		end
		yyvsc22 := yyvsc22 + yyInitial_yyvs_size
		yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
	end
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 332 then
--|#line 2153 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2153")
end

yyval22 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp22 := yyvsp22 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp22 >= yyvsc22 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs22")
		end
		yyvsc22 := yyvsc22 + yyInitial_yyvs_size
		yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
	end
	yyspecial_routines22.force (yyvs22, yyval22, yyvsp22)
end
when 333 then
--|#line 2158 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2158")
end

create yyval13.make (yyvs14.item (yyvsp14), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp13 := yyvsp13 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp13 >= yyvsc13 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs13")
		end
		yyvsc13 := yyvsc13 + yyInitial_yyvs_size
		yyvs13 := yyspecial_routines13.aliased_resized_area (yyvs13, yyvsc13)
	end
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
when 334 then
--|#line 2160 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2160")
end

create yyval13.make (yyvs14.item (yyvsp14), yyvs13.item (yyvsp13)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
when 335 then
--|#line 2165 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2165")
end

create {XPLAIN_SQL_STATEMENT} yyval47.make ("") 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
when 336 then
--|#line 2167 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2167")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
when 337 then
--|#line 2172 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2172")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp37 := yyvsp37 + 1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 338 then
--|#line 2173 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2173")
end

yyval37 := yyvs37.item (yyvsp37) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 339 then
--|#line 2178 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2178")
end

			if attached yyvs38.item (yyvsp38) as s then create yyval37.make (s, Void) end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp38 := yyvsp38 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 340 then
--|#line 2182 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2182")
end

			if attached yyvs38.item (yyvsp38) as s then create yyval37.make (s, yyvs37.item (yyvsp37)) end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp38 := yyvsp38 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 341 then
--|#line 2186 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2186")
end

			if attached yyvs47.item (yyvsp47) as s then create yyval37.make (s, Void) end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp37 := yyvsp37 + 1
	yyvsp47 := yyvsp47 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 342 then
--|#line 2190 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2190")
end

			if attached yyvs37.item (yyvsp37) as s then create yyval37.make (yyvs47.item (yyvsp47), s) end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp47 := yyvsp47 -1
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 343 then
--|#line 2194 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2194")
end

			if equal (text, "end") then
				report_error ("Unexpected 'end' in stored procedure. '.' missing in last statement?")
				abort
			else
				report_error ("Stumbled upon: " + text)
				abort
		end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 344 then
--|#line 2204 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2204")
end

report_error ("A base statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 345 then
--|#line 2206 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2206")
end

report_error ("A type statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 346 then
--|#line 2208 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2208")
end

report_error ("An assert statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 347 then
--|#line 2210 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2210")
end

report_error ("An init statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 348 then
--|#line 2212 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2212")
end

report_error ("A procedure statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
when 349 then
--|#line 2217 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2217")
end

yyval38 := yyvs44.item (yyvsp44) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 350 then
--|#line 2219 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2219")
end

yyval38 := yyvs43.item (yyvsp43) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp43 := yyvsp43 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 351 then
--|#line 2221 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2221")
end

yyval38 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 352 then
--|#line 2223 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2223")
end

yyval38 := yyvs45.item (yyvsp45) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp45 := yyvsp45 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 353 then
--|#line 2225 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2225")
end

yyval38 := yyvs48.item (yyvsp48) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp48 := yyvsp48 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 354 then
--|#line 2227 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2227")
end

yyval38 := yyvs49.item (yyvsp49) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp49 := yyvsp49 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 355 then
--|#line 2229 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2229")
end

yyval38 := yyvs50.item (yyvsp50) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp38 := yyvsp38 + 1
	yyvsp50 := yyvsp50 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
when 356 then
--|#line 2239 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2239")
end

			create yyval47.make (yyvs2.item (yyvsp2))
			if immediate_output_mode then
				sqlgenerator.write_sql (yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp47 := yyvsp47 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
				else
					debug ("GEYACC")
						std.error.put_string ("Error in parser: unknown rule id: ")
						std.error.put_integer (yy_act)
						std.error.put_new_line
					end
					abort
				end
		end

	yy_do_error_action (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			when 634 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER]
			-- Template for `yytranslate'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 366)
			yytranslate_template_1 (an_array)
			yytranslate_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytranslate_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,  126,  118,    2,    2,
			  121,  122,  116,  114,  123,  115,  120,  117,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,  125,  128,
			  110,  108,  111,  124,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,  129,    2,  130,    2,  127,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2, yyDummy>>,
			1, 200, 0)
		end

	yytranslate_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  109,  112,  113,  119, yyDummy>>,
			1, 167, 200)
		end

	yyr1_template: SPECIAL [INTEGER]
			-- Template for `yyr1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 356)
			yyr1_template_1 (an_array)
			yyr1_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yyr1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			    0,  241,  241,  241,  241,  131,  132,  242,  242,  243,
			  243,  243,  243,  243,  215,  215,  215,  216,  216,  216,
			  220,  220,  220,  220,  220,  220,  220,  220,  221,  221,
			  225,  248,  225,  133,  133,  133,  237,  244,  249,  245,
			  250,  224,  222,  223,  251,  223,  252,  135,  135,  135,
			  135,  136,  136,  137,  137,  138,  138,  138,  139,  140,
			  140,  141,  141,  142,  143,  143,  144,  144,  144,  145,
			  145,  147,  147,  146,  146,  146,  146,  146,  146,  146,
			  146,  146,  146,  146,  146,  148,  148,  148,  148,  148,
			  148,  149,  149,  150,  150,  151,  151,  151,  152,  152,

			  153,  153,  153,  153,  153,  153,  153,  153,  153,  153,
			  153,  153,  153,  153,  153,  153,  153,  153,  153,  153,
			  153,  154,  154,  155,  155,  156,  156,  157,  158,  253,
			  159,  159,  159,  160,  161,  254,  255,  255,  257,  258,
			  258,  256,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  163,  163,  163,  164,  165,  166,  167,
			  168,  169,  169,  169,  170,  170,  170,  170,  170,  171,
			  171,  172,  172,  173,  174,  175,  176,  180,  180,  181,
			  181,  182,  182,  182,  182,  182,  182,  182,  182,  177,
			  177,  177,  178,  178,  178,  179,  179,  179,  179,  179, yyDummy>>,
			1, 200, 0)
		end

	yyr1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  179,  179,  134,  134,  183,  259,  183,  183,  184,  260,
			  246,  247,  261,  247,  262,  247,  263,  247,  264,  185,
			  185,  186,  186,  186,  217,  217,  219,  219,  219,  219,
			  232,  232,  232,  232,  232,  187,  187,  187,  188,  189,
			  189,  226,  265,  227,  227,  227,  228,  229,  190,  191,
			  191,  191,  191,  191,  238,  238,  192,  192,  218,  218,
			  218,  218,  218,  239,  193,  193,  193,  193,  193,  193,
			  193,  193,  193,  193,  193,  193,  193,  240,  194,  194,
			  195,  231,  230,  196,  267,  196,  197,  197,  198,  198,
			  198,  198,  199,  199,  200,  200,  201,  201,  202,  202,

			  202,  202,  203,  204,  204,  204,  204,  204,  204,  204,
			  205,  205,  206,  206,  206,  206,  207,  207,  208,  208,
			  208,  209,  209,  266,  233,  268,  269,  234,  234,  234,
			  234,  210,  210,  211,  211,  236,  236,  212,  212,  213,
			  213,  213,  213,  213,  213,  213,  213,  213,  213,  214,
			  214,  214,  214,  214,  214,  214,  235, yyDummy>>,
			1, 157, 200)
		end

	yytypes1_template: SPECIAL [INTEGER]
			-- Template for `yytypes1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 636)
			yytypes1_template_1 (an_array)
			yytypes1_template_2 (an_array)
			yytypes1_template_3 (an_array)
			yytypes1_template_4 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytypes1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    1,    1,    1,    2,    2,    2,    2,    2,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    4,    2,    2,   21,   38,   38,   38,   38,   38,
			   38,   38,   38,   38,   39,   40,   41,   43,   44,   45,
			   38,   46,    3,   47,   15,   48,   49,   50,    1,    1,
			    1,    1,    1,    1,    1,    2,    1,    1,    1,    2,
			    2,    1,    2,    2,   25,    2,    1,    2,    2,    2,
			   25,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    2,   25,   31,   32,   27,   34,    2,   28,    2,

			   25,    2,    1,    2,    2,    2,    2,    2,    1,    1,
			    1,   46,    1,    1,    2,    1,    1,    2,    1,    1,
			    1,    2,   16,    1,    1,    1,    1,    1,   18,    2,
			   38,    1,    1,    1,    1,   15,    2,   25,    1,   35,
			    1,   25,    1,    1,    1,   16,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,   17,    1,   17,    1,
			    1,    1,    1,    1,    6,    6,    2,    2,    1,    1,
			    1,    2,    1,    1,    2,    1,    1,    1,    1,    1,
			    1,    1,    3,    2,    2,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,   11,   12,    2, yyDummy>>,
			1, 200, 0)
		end

	yytypes1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    2,    2,    3,    2,   10,   10,   10,   10,    9,   10,
			   10,   10,   26,   27,   34,   14,    2,   14,    2,    1,
			    2,    2,    2,   23,   24,   14,    3,    3,    1,   38,
			    1,    1,   23,   15,   15,   35,    1,    1,    1,    1,
			    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
			   11,   12,   10,   10,   10,    2,   13,   14,    2,    2,
			    2,   35,   16,   25,    1,   16,   28,    1,    1,    1,
			    9,   10,   10,   11,   10,   13,    1,    3,    1,    1,
			    3,    1,    3,    1,    3,   41,    1,    6,    1,   21,
			    1,    2,    2,    6,    7,    8,    2,    3,    1,   40,

			    1,   22,    1,    1,    1,    1,    2,    1,    2,   14,
			   14,   10,    9,    1,   10,    2,   10,   10,   10,   10,
			   10,    1,   11,    2,   17,    1,    1,    1,    1,    1,
			    1,    1,    1,    2,    1,    1,    1,    1,   17,   25,
			    1,    1,    1,   16,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,   19,   20,   14,    1,   14,   23,    1,
			   16,    2,   14,   14,   10,    1,   13,   10,   10,   10,
			   10,   10,   35,    9,    9,    1,   36,    1,    1,    2,
			    1,    1,    1,    2,    1,    1,    1,   33,    1,    1,
			   22,   10,   16,    2,   29,   14,    9,   10,    1,    1, yyDummy>>,
			1, 200, 200)
		end

	yytypes1_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   11,   10,   13,    1,    1,    1,    1,    2,    1,    1,
			    1,    1,    1,   14,    2,    2,    1,    1,    1,    1,
			   10,   10,   14,   13,   47,   47,    1,    2,    1,    1,
			    2,    1,    1,    1,   10,    1,    1,    1,    1,    1,
			    9,   10,   10,   10,   10,   10,    9,   10,    2,   16,
			    2,    2,   23,    1,   10,   10,   14,   14,   14,   14,
			    1,    1,   14,   14,   33,    1,    1,   10,    1,    1,
			    1,    1,    1,    1,    1,    2,    2,    1,   10,   10,
			   13,    2,    1,   13,   33,   22,   14,   22,   17,    1,
			    1,   14,    9,    2,   10,    9,    1,    1,   10,    3,

			    1,    5,    6,    1,    2,    2,    7,    8,    1,    1,
			    1,    1,    1,    2,   22,    1,    1,   35,   10,    1,
			   16,    9,    1,   19,    1,    1,   35,    1,   10,   10,
			    1,    1,   35,   13,    1,    1,    1,    1,   10,   30,
			   27,    1,   10,    1,    1,   10,   27,   42,    1,    1,
			   13,   46,   22,    1,   22,    1,    1,    1,    1,    1,
			    1,   10,   16,    1,    1,    1,    1,    1,   33,   22,
			    9,    1,    1,    9,    1,   30,    1,    1,    1,    1,
			    1,    1,   37,   37,   38,   43,   44,   45,   38,   47,
			   48,   49,   50,   22,   10,    9,   10,   10,   10,   10, yyDummy>>,
			1, 200, 400)
		end

	yytypes1_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   33,    1,   13,    1,   13,   13,    1,    1,    1,    1,
			    1,    1,    1,   37,    1,    1,    1,    1,   37,    2,
			    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,   16,   16,    1,    1,    1, yyDummy>>,
			1, 37, 600)
		end

	yytypes2_template: SPECIAL [INTEGER]
			-- Template for `yytypes2'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    2,    2,    2,    2,    3,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER]
			-- Template for `yydefact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 636)
			yydefact_template_1 (an_array)
			yydefact_template_2 (an_array)
			yydefact_template_3 (an_array)
			yydefact_template_4 (an_array)
			Result := yyfixed_array (an_array)
		end

	yydefact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    4,    0,  171,    0,    6,  356,    0,  329,
			  328,  330,  327,    0,    0,    0,    0,    0,    0,    0,
			   38,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   13,   21,    0,  158,   25,    0,   14,   15,  224,  225,
			   17,   18,   28,   29,   24,   19,  229,  227,  259,  258,
			  228,   16,  325,    0,   20,  226,  260,  262,    0,    8,
			   22,   23,   26,   27,  261,  172,    5,    0,    0,  212,
			  156,    0,  277,  249,    0,    0,    0,   44,   42,  159,
			    0,   40,    0,  173,  305,  309,  308,  304,  303,  306,
			  307,    0,  310,  281,  292,  293,    0,    0,  282,  323,

			  321,    0,  210,    0,    0,  157,    0,  209,    0,    0,
			    0,    0,   11,    0,  214,    0,    0,  216,    0,    0,
			    0,  250,  248,    0,  255,    0,    0,  155,    0,   46,
			    0,    0,    0,  232,    0,   37,  129,  310,    0,  321,
			    0,  316,  284,  285,    0,  247,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  152,   41,  242,    0,    0,
			  205,    0,    0,   50,    0,   49,   48,   63,   31,   32,
			   12,  331,    0,    0,  218,    0,    0,    0,    0,    0,
			    0,    0,  174,  175,  276,    0,    0,    0,    0,    0,
			    0,   91,   93,    0,   94,    0,   92,  186,  269,  196, yyDummy>>,
			1, 200, 0)
		end

	yydefact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  198,  185,  121,  122,  264,  183,  191,  194,  176,  177,
			  179,  263,    0,  265,    0,  251,    0,  127,  169,  253,
			    0,    0,  256,  321,    0,    0,    0,    0,    0,    0,
			    0,    0,  230,   39,    0,  321,    0,    0,    0,    0,
			    0,  120,  110,    0,    0,    0,    0,    0,    0,    0,
			  115,  102,  318,   96,   99,  114,  100,  123,    0,  160,
			  113,  311,  296,  219,    0,  321,    0,    0,    0,    0,
			  322,   72,   70,  115,    0,  100,  150,    0,  148,  147,
			    0,  145,    0,  143,    0,    0,   34,   35,  206,    0,
			   60,    0,   59,   47,   51,   52,   53,   55,    0,    0,

			    0,  335,    0,    3,    0,    0,    0,    0,    0,  268,
			  199,  183,    0,    0,  197,  266,    0,    0,    0,    0,
			    0,    0,  187,  184,  278,    0,    0,   88,   86,   87,
			   85,   90,   89,    0,    0,    0,    0,    0,    0,  316,
			    0,  252,    0,  254,    0,  237,    0,  154,  153,    0,
			    0,    0,    0,   36,    0,  165,    0,   43,  231,    0,
			  296,    0,  116,  117,    0,    0,  101,    0,    0,    0,
			    0,    0,    0,  133,    0,    0,  312,   65,   64,    0,
			   68,   67,   66,    0,    0,    0,    0,  294,  219,    0,
			  233,  317,  302,    0,    0,  117,    0,    0,    0,    0, yyDummy>>,
			1, 200, 200)
		end

	yydefact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  115,    0,  100,    0,    0,   90,   89,    0,    0,  151,
			  146,  144,  142,    0,  208,  202,    0,    0,    0,    0,
			  207,    0,  333,  332,  336,    0,    2,    0,    0,    0,
			    0,    0,  195,  181,    0,  273,  272,  271,  270,    0,
			    0,  190,  189,  188,  193,  192,  178,  180,  279,  321,
			  170,  257,  236,    0,  239,  238,    0,  168,  167,  166,
			    0,  163,   45,    0,  295,    0,  111,    0,  107,  106,
			  105,  104,    0,  103,    0,  320,  319,    0,   95,   98,
			  124,  126,    0,  298,  297,  234,    0,  220,  287,    0,
			   81,  117,    0,    0,   71,   69,   78,   77,   79,    0,

			    0,    0,  203,   62,    0,   61,   54,   56,   57,   30,
			    0,  326,    0,    0,  211,    0,  274,    0,    0,  182,
			  280,    0,  164,  162,    0,  118,    0,  112,    0,    0,
			  315,  314,  313,  299,    0,    0,  223,    0,  288,  283,
			    0,   82,   80,  149,    0,  244,    0,  241,    0,   58,
			  334,    0,  213,    0,  215,  275,    0,  200,  240,    0,
			    0,  130,  128,  119,    0,  108,    0,    0,  300,  222,
			    0,    0,  291,    0,    0,  204,    0,    0,    0,    0,
			    0,  343,    0,  338,    0,  350,  349,  352,  351,    0,
			  353,  354,  355,  217,    0,    0,  134,    0,    0,   97, yyDummy>>,
			1, 200, 400)
		end

	yydefact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  301,  289,  290,  245,  246,  243,  348,  345,  347,  344,
			  346,  324,    0,  342,  201,  131,    0,  109,  340,  140,
			  139,    0,    0,    0,    0,  132,    0,  135,  137,  136,
			    0,    0,  138,  141,    0,    0,    0, yyDummy>>,
			1, 37, 600)
		end

	yydefgoto_template: SPECIAL [INTEGER]
			-- Template for `yydefgoto'
		once
			Result := yyfixed_array (<<
			    3,    5,   31,  501,  164,  293,  294,  295,  165,  291,
			  504,  166,  379,  383,  270,  271,  272,  333,  250,  251,
			  397,  253,  254,  255,  256,  257,  215,  135,  562,  374,
			  597,  156,  128,  136,  104,  200,   78,  258,  353,  354,
			  217,  259,  260,  202,  203,  204,  205,  206,  207,  208,
			  209,  210,   34,  415,  390,  487,  223,  224,  455,   74,
			  122,  225,  211,  212,  213,   98,  394,  539,   93,   94,
			  387,  484,  540,  214,  139,  261,  265,  376,  145,  301,
			  423,  582,  583,  584,   35,   36,   37,   38,   39,   40,
			   41,   42,   43,   44,   45,   46,  547,  605,   47,   48,

			   49,   50,   51,   52,   53,  425,   54,   55,   56,   57,
			  634,   58,   59,   60,   61,   62,   63,  299,   82,  134,
			  130,  229,  234,  621,  622,  627,  623,  624,  289,  108,
			  116,  173,  176,  305,  285,   64,  266,  111,  551, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER]
			-- Template for `yypact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 636)
			yypact_template_1 (an_array)
			yypact_template_2 (an_array)
			yypact_template_3 (an_array)
			yypact_template_4 (an_array)
			Result := yyfixed_array (an_array)
		end

	yypact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			   66,  180, -32768, 1546,  180,  491, -32768, -32768,   47, -32768,
			 -32768, -32768, -32768,  180,  521,  180,  180,  180,   12,  180,
			  590,  850,  180,  506,  180,  180,  599,  180,  180,  180,
			 -32768, -32768,  490, -32768, -32768,  477, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, 1296, -32768, -32768, -32768, -32768,  578, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,  180,  505, -32768,
			 -32768,  180,  485,  187,   72,   25,  180, -32768, -32768,  568,
			   76, -32768,  180, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  180,  546, -32768,  567, -32768,  180,  253, -32768, -32768,

			  354,  809, -32768,  564,  809, -32768,  200,  179,  103,   67,
			 1136,  180, -32768,  468, -32768,  180,  559, -32768,  990,  180,
			   26, -32768, -32768,  180, -32768,  486,  483, -32768,  471, -32768,
			  554,  547,  180, -32768,  180, -32768, -32768,  546, 1399,  354,
			  180,  437, -32768, -32768, 1230, -32768,  448,  467,  447,  444,
			  465,  435,  464,  434,  457, -32768, -32768, -32768,  177,  553,
			 -32768,  242,  -62, -32768,  443, -32768, -32768, -32768, -32768, -32768,
			 -32768,  501,  305,  520, -32768,  180,  514,  180,  180,  180,
			  302,  563, -32768, -32768, -32768,  180,  990,  990,  990,  990,
			 1399, -32768, -32768,  224, -32768,  809, -32768, -32768, -32768, -32768, yyDummy>>,
			1, 200, 0)
		end

	yypact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -32768,  810,  232, -32768, -32768,  500,
			  531, -32768,  149, -32768,  180, -32768,  403, -32768,  397, -32768,
			  401,  398,  397,  354,   54,  414,  394,  390,  218,  484,
			  180,  180, -32768, -32768,  481,  354,  180,  180,  180, 1399,
			  -56, -32768, -32768, 1399, 1399, 1399, 1399, 1399, 1399, 1230,
			 -32768, -32768,  504,  272,  258, -32768, -32768,  480,  377,  730,
			 -32768, -32768,  424,   -3, 1399,  354,  180,  180, 1230, 1560,
			 -32768,  499,  459,  772,  711,  664, -32768,   20, -32768, -32768,
			  379, -32768,  378, -32768,  376,  180, -32768, -32768, -32768,  180,
			 -32768,  374, -32768, -32768, -32768, -32768,  369,  -82,  990,  302,

			  180,  385,  476, -32768,  180,  449,  365,  180,  351, -32768,
			 -32768,  691,  349,  563, -32768, -32768,  348,  346,  345,  344,
			  341,  302, -32768, -32768, -32768,  563,  563, -32768, -32768, -32768,
			 -32768, -32768, -32768,  563,  563,  563,  302,  302,  324,  437,
			  180, -32768,  180, -32768,  180, -32768, 1480, -32768, -32768,  180,
			  180,  180,  180, -32768,   62, -32768,  180, -32768, -32768,  180,
			  424,  335, -32768, -32768,  333, 1399, -32768,  331,  330,  326,
			  320,  328,  319, -32768,  400,  287,  312, -32768, -32768, 1399,
			 -32768, -32768, -32768, 1640,  180,  180,  -46, -32768,  406,  180,
			 -32768, -32768, -32768,  615,  325,  605,  309,  375,  180, 1230, yyDummy>>,
			1, 200, 200)
		end

	yypact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  502,  640,  409, 1230, 1230,  396,  395, 1399,  327, -32768,
			 -32768, -32768, -32768,  316, -32768,  300,  115,  324,  321,  415,
			 -32768,  291,  288, -32768, -32768,  301, -32768,  299,  180,  180,
			  297, 1391, -32768, -32768,  237, -32768, -32768, -32768, -32768, 1399,
			  281,  232,  232,  211, -32768, -32768, -32768, -32768, -32768,  354,
			 -32768, -32768, -32768, 1230, -32768, -32768,  265, -32768, -32768, -32768,
			  218, -32768, -32768,  264, -32768, 1310, -32768,  262, -32768, -32768,
			 -32768, -32768, 1399, -32768, 1399, -32768, -32768, 1150, -32768, -32768,
			 -32768, -32768,  180,  223, -32768, -32768,   60, -32768, -32768,  845,
			 -32768,  154,  255, 1399, -32768, -32768, -32768, -32768, -32768,  248,

			  945,  249, -32768, -32768,  245, -32768, -32768, -32768, -32768, -32768,
			  180, -32768,  180,  235, -32768,  180, -32768,  215,  107, -32768,
			 -32768,  213, -32768, -32768, 1070, -32768,  208, -32768,  -38,  304,
			 -32768, -32768, -32768,  171,  -46,  180, -32768, 1230, -32768, -32768,
			   23, -32768, -32768, -32768, 1230, -32768,  266, -32768,  845, -32768,
			 -32768, 1785, -32768,  180, -32768, -32768, 1399, -32768, -32768, 1230,
			 1399, -32768, -32768, -32768, 1399, -32768, 1399,  -46, -32768, -32768,
			  162,  180, -32768,  159,  180, -32768,  271,  269,  261,  244,
			  238, -32768,  219, -32768,   56, -32768, -32768, -32768, -32768, 1752,
			 -32768, -32768, -32768, -32768,  101,   78, -32768,  161,   69, -32768, yyDummy>>,
			1, 200, 400)
		end

	yypact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, 1696, -32768, -32768, -32768,  -62, -32768, -32768, -32768,
			 -32768,  169,  142,   34,   13, -32768,   10, -32768, -32768, -32768,
			 1070, 1070, -32768, -32768,  122,   89, -32768, yyDummy>>,
			1, 37, 600)
		end

	yypgoto_template: SPECIAL [INTEGER]
			-- Template for `yypgoto'
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768, -32768,  488, -32768,  230,  220,  229, -32768,
			 -32768, -32768, -32768, -32768, -206, -32768,  234, -267,  250,  -96,
			   43,  260, -32768,  372,   92,  388, -164,  497, -238, -32768,
			 -32768, -100, -32768,   -1, -32768,   35, -32768,  283,  160, -32768,
			  226,   29,  -21, -157, -32768,  329, -160,   65, -163, -161,
			  286, -32768, -32768, -32768,  233, -389, -123, -32768, -32768,  -13,
			 -32768, -205,  -71, -32768, -32768, -32768, -32768,   70, -32768, -32768,
			  254, -503,  -19,  -20,  482, -245,  274, -32768, -129, -32768,
			  102, -32768, -513, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -309, -348,

			 -354, -393, -32768, -32768, -288, -32768, -32768, -470, -479, -480,
			 -32768, -32768,  -24, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,  -12, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER]
			-- Template for `yytable'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1879)
			yytable_template_1 (an_array)
			yytable_template_2 (an_array)
			yytable_template_3 (an_array)
			yytable_template_4 (an_array)
			yytable_template_5 (an_array)
			yytable_template_6 (an_array)
			yytable_template_7 (an_array)
			yytable_template_8 (an_array)
			yytable_template_9 (an_array)
			yytable_template_10 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytable_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   91,   96,   95,  372,  158,  297,   80,  407,   92,  232,
			  262,  100,   69,  424,  309,  310,   75,   77,  314,  312,
			  311,  409,  198,  389,  572,  357,  127,  219,  106,  112,
			    6,  568,   33,   65,   83,   76,  182,  419,   32,    4,
			  514,  418,   70,  373,   72,   73,   70,   79,   73,    4,
			   73,   97,  121,   73,   33,  345,  103,  105,  107,  571,
			  101,  536,  396,  461,  600,  365,  114,    2,  169,  482,
			  117,  592,  591,  124,  363,  129,  613,  133,  137,    1,
			  413,  590,   33,  141,  565,  564,  170,  167,   32,  636,
			  198,  198,  198,  198,  343,  324,   70,  201,  123,  618,

			   70, -235,  132,  395,  163,   70,  360,    4,  358,  592,
			  591,   70,  338,  388,  174,  316,  317,  318,  319,  590,
			   73,    4,  635,  552,  126,   73,  554,  263,  125,   68,
			  407,   67,  592,  591,  493,  631,  392,  167,  630,   33,
			  171,  296,  590,  408,   70,   32,  569,   33,  218,  220,
			  155,  462,  222,  434,  463,  -76,  626,  -76,  588,  201,
			  440,  222,  629,   70,  593,  201,  201,  201,  201,   73,
			  625,  444,  445,  443, -235,  446,  612,  344,  163,  -76,
			 -221,  252, -161,  535,  315,  460,  517,  274,  168,  -76,
			  -76,  617,  131,  492,  -76,  616,  588,  587,  495,   83, yyDummy>>,
			1, 200, 0)
		end

	yytable_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  615,  339,  198,  586,  306, -156,  308,  218,  218,   33,
			   33,  162,  183,  182,   70,   33,   33,   33,   33,  588,
			  526,  452,   33,  614,  161, -156,  160,  420,  323,  557,
			  556,  503,  532,  320,  491,  587,  275,  611,   83,  610,
			  182,  586,  585,   73,  196,  609,  159,  521,  154,  153,
			  152,  151,  150,  149,  148,  147,  146,  218,  587,  222,
			  222,  297,  608,  589,  586,  361,  191,  218,  286, -267,
			  607, -267,  606,   83,  -76,    4,  -76,  201,  201,  143,
			  585,  603,  364,   83,  601,  162,  367,  368,  369,  370,
			  371,  252,  274,  488,  567,  393,  218,  -33,  161,  142,

			  201,  589,  574,  585,  352,   -1,  303,  391,  120,  351,
			  350,  119,  401,    4,  222,  201,  201,  448,  414,    4,
			  520,  566,  196,  302,  589,  326,  325,   33,   33,  218,
			  563,  570,  366,  427,  193,  558,  430,  555,  573,  183,
			  182,  275,   33,  553,  191,  321,  534,  349,  335,  334,
			   33,  326,  325,  595,   33,   33,  190,  548,  290,  432,
			  275,  402,   33,   33,   33,   33,   33,  549,  197,  450,
			  543,  451,  524,  222,  382,  381,  380,  541,  218,  218,
			  218,  218,    4,  475,  527,  222,  378,  377,  222,  454,
			  441,  442,  632,  633,  273,  522,  296,    4,   83,  183, yyDummy>>,
			1, 200, 200)
		end

	yytable_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  182,  144,  216,  519,  476,  515,  221,  512,  467,  511,
			  -74,  510,  -74,  509,  481,  221,  508,  181,  218,  182,
			   83,  161,  478,  180,  500,  499,  179,  218,  497,  496,
			  197,  490,  389,  489,  -74,  477,  197,  197,  197,  197,
			  474,  473,  471,  322,  -74,  -74,  274,  274,  470,  -74,
			  498,  472,  469,  468,  355,  466,  465,  513,  218,  620,
			  386,  216,  216,  264,  439,  620,  438,  437,  436,   96,
			  435,  433,  431,  429,  252,  428,  480,  426,  483,    7,
			   96,  546,  518,  406,  405,  330,  329,  328,  327,  218,
			  199,  275,  417,  416,  404,  275,  275,  466,  412,  273,

			  411,  410,  403,  -84,  385,  -84,  384,  359,  252,  375,
			  356,  216,  348,  221,  221,  528,  347,  529,  273,  400,
			  252,  216,  346,  341, -160,  342,  422,  -84,   96,  -74,
			  340,  -74,  538,  292,  337,  336,  542,  -84,  -84,  218,
			  307,  218,  -84,  545,  218,  275,  304,  300,  197,  197,
			  216,  298,  199,  199,  288,  284,  283,  281,  199,  199,
			  199,  199,  282,  280,  218,  277,  279,  561,  221,  278,
			  276,  197,  138,  231,  533,  456,  457,  458,  459,  228,
			  230,  227,  218,  216,  226,  175,  197,  197,  172,  115,
			  157,  538,  140,  118, -156,  619,  113,  110,  109,  594, yyDummy>>,
			1, 200, 400)
		end

	yytable_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  102,  619,   99,  596,   81,   71,  -75,  598,  -75,  599,
			  628,   66,  550,  449,  464,  486,  155,  190,  575,  235,
			  523,  485,  -84,  447,  -84,  362,  483,  221,  421,  275,
			  -75,  233,  216,  216,  216,  216,  275,  494,  507,  221,
			  -75,  -75,  221,  479,  502,  -75,  287,  506,    0,  273,
			    0,  275,    0,  273,  273,  486,    0,    0,    4,  483,
			  183,  182,    0,  602,    0,  -73,  604,  -73,    0,    0,
			  199,  199,  216,  561,  561,    0,    0,    0,  181,    0,
			    0,  216,    0,    0,  313,  199,  355,  179,    0,  -73,
			    0,    0,    0,  199,    0,    0,    0,  199,  199,  -73,

			  -73,    0,    0,  273,  -73,  199,  199,  199,  199,  199,
			    0,    0,  216,    0,  154,  153,  152,  151,  150,  149,
			  148,  147,  146, -286,    0,  -75,    0,  -75,    0,    0,
			    0, -125,    0, -125,    0, -125,  422,    0,  486,    0,
			    0,  486,    0,  216, -125,    0,    0, -125,  332,  331,
			  330,  329,  328,  327,    0, -125, -125,    0,    0,    0,
			    0,  486,    0,    0, -125, -125, -125,    0,    0,    0,
			 -125,    0,    0,  -83,    0,  -83,    0, -125,    0,  486,
			    0,    0,    0,    0,  -73,    0,  -73,  273,  505,    0,
			    0,    0,    0,  216,  273,  216,    0,  -83,  216,  332, yyDummy>>,
			1, 200, 600)
		end

	yytable_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  331,  330,  329,  328,  327,  326,  325,  -83,  -83,  273,
			  155,    0,  -83,  432,    0,    0,    0,    0,  216,  406,
			  405,  330,  329,  328,  327,    0, -125,    0, -125,    0,
			    0,    0,    0,    0,    0,    0,  216,    0, -125, -125,
			 -125, -125, -125, -125, -125, -125, -125, -125, -125,   90,
			 -125,    0, -125, -125,   90,    0,    0,   89, -125,    0,
			    0,    0,   89,    0,    0,  196,    0,  249,    0,    0,
			    0,    0,  194,   88,   87,    0,   86,    0,   88,   87,
			    0,   86,    0,   85,  192,    0,   84,  191,   85,    0,
			    0,   84,  -83,  248,  -83,    0,    0,    0,    0,  247,

			    0,    0,    0,  246,  245,  244,  243,    0,  154,  153,
			  152,  151,  150,  149,  148,  147,  146,    0,  332,  331,
			  330,  329,  328,  327,  326,  325,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  242,  241,
			    4,   83,  183,  182,    0,    4,   83,    0,    0,   90,
			    0,    0,    0,    0,    0,    0,    0,   89,    0,    0,
			  240,    0,    0,    0,    0,  196,  537,  249,    0,  238,
			  237,  236,  194,   88,   87,    0,   86,    0,    0,    0,
			    0,    0,    0,   85,  192,    0,   84,  191,    0,    0,
			    0,    0,    0,  248,   90,    0,    0,    0,    0,  247, yyDummy>>,
			1, 200, 800)
		end

	yytable_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,   89,  246,  245,  244,  243,    0,    0,    0,
			  196,    0,    0,    0,  195,    0,    0,  194,   88,   87,
			    0,   86,  193,    0,    0,    0,    0,    0,   85,  192,
			    0,   84,  191,    0,    0,    0,    0,    0,  242,  241,
			    4,   83,  183,  182,  190,    0,    0,    0,  189,  188,
			  187,  186,    0,    0,    0,    0,    0,    0,    0,    0,
			  240,    0,    0,    0,    0,    0,  544,    0,    0,  238,
			  237,  236,    0,    0,    0,  185,    0,    0,    0,  560,
			    0,    0,    0,    0,  184,    4,   83,  183,  182,    0,
			  196,    0,  249,    0,    0,    0,    0,  194,    0,    0,

			    0,    0,    0,    0,    0,  181,    0,    0,    0,  192,
			    0,  180,  191,    0,  179,  178,  177,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,   30,    0,    0,
			    0,    0,   29,   28,   27,    0,   26,   25,    0,    0,
			    0,   24,   23,    0,   -9,   22,    0,   21,    0,   20,
			    0,   19,    0,  242,  241,    4,   83,  183,  182,    0,
			  196,    0,  249,   18,    0,    0,  531,  194,    0,   17,
			   16,   15,    0,    0,    0,  240,    0,    0,    0,  192,
			    0,  559,  191,    0,  238,  237,  236,    0,  248,    0, yyDummy>>,
			1, 200, 1000)
		end

	yytable_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,    0,   14,    0,
			   13,    0,    0,   12,   11,   10,    9,    0,    8,    0,
			    7,    4,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  242,  241,    4,   83,  183,  182,    0,
			  196,    0,  249,    0,    0,    0,    0,  194,    0,    0,
			    0,    0,  269,    0,    0,  240,    0,    0,    0,  192,
			    0,  239,  191,  530,  238,  237,  236,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,   30,    0,    0,

			    0,    0,   29,   28,   27,    0,   26,   25,    0,    0,
			    0,   24,   23,    0,  -10,   22,    0,   21,    0,   20,
			    0,   19,    0,  242,  241,    4,   83,  183,  182,    0,
			  196,    0,  249,   18,    0,    0,    0,  194,    0,   17,
			   16,   15,    0,    0,    0,  240,    0,    0,    0,  192,
			    0,  268,  191,    0,  267,  237,  236,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,    0,   14,    0,
			   13,    0,    0,   12,   11,   10,    9,    0,    8,    0,
			    7,    4,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 1200)
		end

	yytable_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,  242,  241,    4,   83,  183,  182,    0,
			    0,  196,    0,  249,    0,    0,    0,    0,  194,  196,
			    0,  249,    0,    0,    0,  240,  194,    0,    0,    0,
			  192,  239,  525,  191,  238,  237,  236,    0,  192,  248,
			    0,  191,    0,    0,    0,  247,    0,  248,    0,  246,
			  245,  244,  243,  247,    0,    0,    0,  246,  245,  244,
			  243,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  242,  241,    4,   83,  183,  182,
			    0,    0,  242,  241,    4,   83,  183,  182,    0,    0,

			  196,    0,  249,    0,    0,    0,  240,  194,    0,    0,
			    0,    0,  239,  516,  240,  238,  237,  236,    0,  192,
			  239,    0,  191,  238,  237,  236,    0,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,   30,    0,    0,
			    0,    0,   29,   28,   27,    0,   26,   25,    0,    0,
			    0,   24,   23,    0,   -7,   22,    0,   21,    0,   20,
			    0,   19,    0,  242,  241,    4,   83,  183,  182,    0,
			  196,    0,  249,   18,    0,    0,    0,  194,    0,   17,
			   16,   15,    0,    0,    0,  240,    0,    0,    0,  192, yyDummy>>,
			1, 200, 1400)
		end

	yytable_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  453,  191,    0,  238,  237,  236,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,    0,  246,  245,
			  244,  243,    0,    0,    0,    0,    0,    0,   14,    0,
			   13,    0,    0,   12,   11,   10,    9,    0,    8,    0,
			    7,    4,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  242,  241,    4,   83,  183,  182,    0,
			  196,    0,    0,    0,    0,    0,    0,  194,    0,    0,
			    0,    0,    0,    0,    0,  240,    0,    0,    0,  192,
			    0,  399,  191,    0,  398,  237,  236,    0,  248,    0,
			    0,    0,    0,    0,  247,    0,    0,  581,  246,  245,

			  244,  243,  580,  579,    0,    0,    0,    0,    0,    0,
			    0,   24,    0,    0, -339,   22,    0,   21,    0,  578,
			    0,   19,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  242,  241,    4,   83,  183,  182,  577,
			   16,   15,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  581,    0,  240,    0,    0,  580,  579,
			    0,  239,    0,    0,  238,  237,  236,   24,    0,    0,
			 -341,   22,    0,   21,    0,  578,    0,   19,    0,    0,
			    0,    0,    0,  576,    0,    0,  581,    0,    0,    0,
			    7,  580,  579,    0,    0,  577,   16,   15,    0,    0, yyDummy>>,
			1, 200, 1600)
		end

	yytable_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   24,    0,    0, -337,   22,    0,   21,    0,  578,    0,
			   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  577,   16,
			   15,    0,    0,    0,    0,    0,    0,    0,    0,  576,
			    0,    0,    0,    0,    0,    0,    7,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  576,    0,    0,    0,    0,    0,    0,    7, yyDummy>>,
			1, 80, 1800)
		end

	yycheck_template: SPECIAL [INTEGER]
			-- Template for `yycheck'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1879)
			yycheck_template_1 (an_array)
			yycheck_template_2 (an_array)
			yycheck_template_3 (an_array)
			yycheck_template_4 (an_array)
			yycheck_template_5 (an_array)
			yycheck_template_6 (an_array)
			yycheck_template_7 (an_array)
			yycheck_template_8 (an_array)
			yycheck_template_9 (an_array)
			yycheck_template_10 (an_array)
			Result := yyfixed_array (an_array)
		end

	yycheck_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   21,   21,   21,  248,  104,  162,   19,  274,   21,  132,
			  139,   24,   13,  301,  178,  179,   17,   18,  181,  180,
			  180,    1,  118,   26,    1,  230,    1,    1,   29,   53,
			    1,  534,    3,    4,   96,   23,   98,  119,    3,   95,
			  429,  123,   13,  249,   15,   16,   17,   18,   19,   95,
			   21,   22,   73,   24,   25,    1,   27,   28,   29,   36,
			   25,    1,  268,    1,  567,  121,   67,    1,    1,  115,
			   71,  551,  551,    1,  238,   76,  589,    1,   91,   13,
			  285,  551,   53,   96,  122,  123,  110,  108,   53,    0,
			  186,  187,  188,  189,  223,  195,   67,  118,   26,  612,

			   71,   47,   26,  267,    1,   76,  235,   95,  231,  589,
			  589,   82,  212,  116,  115,  186,  187,  188,  189,  589,
			   91,   95,    0,  512,   99,   96,  515,  140,  103,   82,
			  397,   84,  612,  612,  401,  125,  265,  158,  125,  110,
			  111,  162,  612,  123,  115,  110,  535,  118,  119,  120,
			    1,  356,  123,  313,  359,    1,   14,    3,  551,  180,
			  321,  132,  128,  134,  553,  186,  187,  188,  189,  140,
			    1,  334,  335,  333,  120,  336,  120,  123,    1,   25,
			  120,  138,  120,  123,  185,  123,  431,  144,  121,   35,
			   36,  122,  116,  399,   40,   34,  589,  551,  404,   96, yyDummy>>,
			1, 200, 0)
		end

	yycheck_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  122,  214,  298,  551,  175,   26,  177,  178,  179,  180,
			  181,  108,   97,   98,  185,  186,  187,  188,  189,  612,
			  465,  344,  193,  122,  121,   46,   26,  298,  193,  122,
			  123,  116,  477,  190,  398,  589,  144,   18,   96,    1,
			   98,  589,  551,  214,   20,    1,   46,  453,   99,  100,
			  101,  102,  103,  104,  105,  106,  107,  228,  612,  230,
			  231,  418,    1,  551,  612,  236,   42,  238,   91,  120,
			    1,  122,    1,   96,  120,   95,  122,  298,  299,   26,
			  589,  122,  239,   96,  122,  108,  243,  244,  245,  246,
			  247,  248,  249,  393,  123,  266,  267,  120,  121,   46,

			  321,  589,   36,  612,   86,    0,    1,  264,  121,   91,
			   92,  124,  269,   95,  285,  336,  337,  338,  289,   95,
			  449,   17,   20,   18,  612,  114,  115,  298,  299,  300,
			  122,  537,  240,  304,   32,  122,  307,  122,  544,   97,
			   98,  249,  313,  108,   42,  121,  123,  129,  116,  117,
			  321,  114,  115,  559,  325,  326,   54,  108,  116,  122,
			  268,  269,  333,  334,  335,  336,  337,  122,  118,  340,
			  122,  342,  108,  344,  116,  117,  118,  122,  349,  350,
			  351,  352,   95,   96,  122,  356,  114,  115,  359,  346,
			  325,  326,  630,  631,  144,  130,  417,   95,   96,   97, yyDummy>>,
			1, 200, 200)
		end

	yycheck_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   98,   47,  119,  122,  375,  108,  123,  108,  365,  108,
			    1,  123,    3,  122,  385,  132,    1,  115,  389,   98,
			   96,  121,  379,  121,  108,   98,  124,  398,   33,   33,
			  180,  122,   26,  108,   25,  123,  186,  187,  188,  189,
			   40,  122,  122,  193,   35,   36,  403,  404,  122,   40,
			  407,  123,  122,  122,  228,  122,  121,  428,  429,  616,
			   36,  178,  179,   26,  123,  622,  122,  122,  122,  489,
			  122,  122,  121,  108,  431,   26,  384,    1,  386,   94,
			  500,  500,  439,  108,  109,  110,  111,  112,  113,  460,
			  118,  399,  123,  119,   35,  403,  404,  122,  122,  249,

			  122,  122,    3,    1,  127,    3,   26,   26,  465,    5,
			   26,  228,  122,  230,  231,  472,  122,  474,  268,  269,
			  477,  238,  108,  122,  127,  127,  300,   25,  548,  120,
			  127,  122,  489,  161,    3,   35,  493,   35,   36,  510,
			   26,  512,   40,  500,  515,  453,   26,   46,  298,  299,
			  267,  108,  180,  181,    1,   98,  122,  122,  186,  187,
			  188,  189,   98,   98,  535,   98,  122,  524,  285,  122,
			  122,  321,   26,   26,  482,  349,  350,  351,  352,  108,
			   26,   98,  553,  300,   98,   26,  336,  337,  120,   84,
			   26,  548,   25,  108,   26,  616,   18,  120,  108,  556, yyDummy>>,
			1, 200, 400)
		end

	yycheck_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			    1,  622,   96,  560,   14,   84,    1,  564,    3,  566,
			  622,  120,  510,  339,  360,  389,    1,   54,  548,  137,
			  460,  388,  120,  337,  122,  237,  534,  344,  299,  537,
			   25,  134,  349,  350,  351,  352,  544,  403,  418,  356,
			   35,   36,  359,  383,  415,   40,  158,  417,   -1,  399,
			   -1,  559,   -1,  403,  404,  429,   -1,   -1,   95,  567,
			   97,   98,   -1,  571,   -1,    1,  574,    3,   -1,   -1,
			  298,  299,  389,  630,  631,   -1,   -1,   -1,  115,   -1,
			   -1,  398,   -1,   -1,  121,  313,  460,  124,   -1,   25,
			   -1,   -1,   -1,  321,   -1,   -1,   -1,  325,  326,   35,

			   36,   -1,   -1,  453,   40,  333,  334,  335,  336,  337,
			   -1,   -1,  429,   -1,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  108,   -1,  120,   -1,  122,   -1,   -1,
			   -1,    1,   -1,    3,   -1,    5,  510,   -1,  512,   -1,
			   -1,  515,   -1,  460,   14,   -1,   -1,   17,  108,  109,
			  110,  111,  112,  113,   -1,   25,   26,   -1,   -1,   -1,
			   -1,  535,   -1,   -1,   34,   35,   36,   -1,   -1,   -1,
			   40,   -1,   -1,    1,   -1,    3,   -1,   47,   -1,  553,
			   -1,   -1,   -1,   -1,  120,   -1,  122,  537,  416,   -1,
			   -1,   -1,   -1,  510,  544,  512,   -1,   25,  515,  108, yyDummy>>,
			1, 200, 600)
		end

	yycheck_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  109,  110,  111,  112,  113,  114,  115,   35,   36,  559,
			    1,   -1,   40,  122,   -1,   -1,   -1,   -1,  535,  108,
			  109,  110,  111,  112,  113,   -1,   96,   -1,   98,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  553,   -1,  108,  109,
			  110,  111,  112,  113,  114,  115,  116,  117,  118,    4,
			  120,   -1,  122,  123,    4,   -1,   -1,   12,  128,   -1,
			   -1,   -1,   12,   -1,   -1,   20,   -1,   22,   -1,   -1,
			   -1,   -1,   27,   28,   29,   -1,   31,   -1,   28,   29,
			   -1,   31,   -1,   38,   39,   -1,   41,   42,   38,   -1,
			   -1,   41,  120,   48,  122,   -1,   -1,   -1,   -1,   54,

			   -1,   -1,   -1,   58,   59,   60,   61,   -1,   99,  100,
			  101,  102,  103,  104,  105,  106,  107,   -1,  108,  109,
			  110,  111,  112,  113,  114,  115,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
			   95,   96,   97,   98,   -1,   95,   96,   -1,   -1,    4,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   12,   -1,   -1,
			  115,   -1,   -1,   -1,   -1,   20,  121,   22,   -1,  124,
			  125,  126,   27,   28,   29,   -1,   31,   -1,   -1,   -1,
			   -1,   -1,   -1,   38,   39,   -1,   41,   42,   -1,   -1,
			   -1,   -1,   -1,   48,    4,   -1,   -1,   -1,   -1,   54, yyDummy>>,
			1, 200, 800)
		end

	yycheck_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   12,   58,   59,   60,   61,   -1,   -1,   -1,
			   20,   -1,   -1,   -1,   24,   -1,   -1,   27,   28,   29,
			   -1,   31,   32,   -1,   -1,   -1,   -1,   -1,   38,   39,
			   -1,   41,   42,   -1,   -1,   -1,   -1,   -1,   93,   94,
			   95,   96,   97,   98,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  115,   -1,   -1,   -1,   -1,   -1,  121,   -1,   -1,  124,
			  125,  126,   -1,   -1,   -1,   85,   -1,   -1,   -1,    9,
			   -1,   -1,   -1,   -1,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   22,   -1,   -1,   -1,   -1,   27,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,  115,   -1,   -1,   -1,   39,
			   -1,  121,   42,   -1,  124,  125,  126,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,    1,   -1,   -1,
			   -1,   -1,    6,    7,    8,   -1,   10,   11,   -1,   -1,
			   -1,   15,   16,   -1,   18,   19,   -1,   21,   -1,   23,
			   -1,   25,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   22,   37,   -1,   -1,   26,   27,   -1,   43,
			   44,   45,   -1,   -1,   -1,  115,   -1,   -1,   -1,   39,
			   -1,  121,   42,   -1,  124,  125,  126,   -1,   48,   -1, yyDummy>>,
			1, 200, 1000)
		end

	yycheck_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,   -1,   82,   -1,
			   84,   -1,   -1,   87,   88,   89,   90,   -1,   92,   -1,
			   94,   95,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   22,   -1,   -1,   -1,   -1,   27,   -1,   -1,
			   -1,   -1,   32,   -1,   -1,  115,   -1,   -1,   -1,   39,
			   -1,  121,   42,  123,  124,  125,  126,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,    1,   -1,   -1,

			   -1,   -1,    6,    7,    8,   -1,   10,   11,   -1,   -1,
			   -1,   15,   16,   -1,   18,   19,   -1,   21,   -1,   23,
			   -1,   25,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   22,   37,   -1,   -1,   -1,   27,   -1,   43,
			   44,   45,   -1,   -1,   -1,  115,   -1,   -1,   -1,   39,
			   -1,  121,   42,   -1,  124,  125,  126,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,   -1,   82,   -1,
			   84,   -1,   -1,   87,   88,   89,   90,   -1,   92,   -1,
			   94,   95,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 1200)
		end

	yycheck_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   -1,   20,   -1,   22,   -1,   -1,   -1,   -1,   27,   20,
			   -1,   22,   -1,   -1,   -1,  115,   27,   -1,   -1,   -1,
			   39,  121,  122,   42,  124,  125,  126,   -1,   39,   48,
			   -1,   42,   -1,   -1,   -1,   54,   -1,   48,   -1,   58,
			   59,   60,   61,   54,   -1,   -1,   -1,   58,   59,   60,
			   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   93,   94,   95,   96,   97,   98,
			   -1,   -1,   93,   94,   95,   96,   97,   98,   -1,   -1,

			   20,   -1,   22,   -1,   -1,   -1,  115,   27,   -1,   -1,
			   -1,   -1,  121,  122,  115,  124,  125,  126,   -1,   39,
			  121,   -1,   42,  124,  125,  126,   -1,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,    1,   -1,   -1,
			   -1,   -1,    6,    7,    8,   -1,   10,   11,   -1,   -1,
			   -1,   15,   16,   -1,   18,   19,   -1,   21,   -1,   23,
			   -1,   25,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   22,   37,   -1,   -1,   -1,   27,   -1,   43,
			   44,   45,   -1,   -1,   -1,  115,   -1,   -1,   -1,   39, yyDummy>>,
			1, 200, 1400)
		end

	yycheck_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,  121,   42,   -1,  124,  125,  126,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,   -1,   58,   59,
			   60,   61,   -1,   -1,   -1,   -1,   -1,   -1,   82,   -1,
			   84,   -1,   -1,   87,   88,   89,   90,   -1,   92,   -1,
			   94,   95,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   93,   94,   95,   96,   97,   98,   -1,
			   20,   -1,   -1,   -1,   -1,   -1,   -1,   27,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  115,   -1,   -1,   -1,   39,
			   -1,  121,   42,   -1,  124,  125,  126,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   54,   -1,   -1,    1,   58,   59,

			   60,   61,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   15,   -1,   -1,   18,   19,   -1,   21,   -1,   23,
			   -1,   25,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   93,   94,   95,   96,   97,   98,   43,
			   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,    1,   -1,  115,   -1,   -1,    6,    7,
			   -1,  121,   -1,   -1,  124,  125,  126,   15,   -1,   -1,
			   18,   19,   -1,   21,   -1,   23,   -1,   25,   -1,   -1,
			   -1,   -1,   -1,   87,   -1,   -1,    1,   -1,   -1,   -1,
			   94,    6,    7,   -1,   -1,   43,   44,   45,   -1,   -1, yyDummy>>,
			1, 200, 1600)
		end

	yycheck_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   15,   -1,   -1,   18,   19,   -1,   21,   -1,   23,   -1,
			   25,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   43,   44,
			   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   87,
			   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   87,   -1,   -1,   -1,   -1,   -1,   -1,   94, yyDummy>>,
			1, 80, 1800)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [detachable ANY]
			-- Stack for semantic values of type detachable ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [detachable ANY]
			-- Routines that ought to be in SPECIAL [detachable ANY]

	yyvs2: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs3: SPECIAL [INTEGER]
			-- Stack for semantic values of type INTEGER

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [INTEGER]
			-- Routines that ought to be in SPECIAL [INTEGER]

	yyvs4: SPECIAL [XPLAIN_BASE]
			-- Stack for semantic values of type XPLAIN_BASE

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [XPLAIN_BASE]
			-- Routines that ought to be in SPECIAL [XPLAIN_BASE]

	yyvs5: SPECIAL [detachable XPLAIN_DOMAIN_RESTRICTION]
			-- Stack for semantic values of type detachable XPLAIN_DOMAIN_RESTRICTION

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [detachable XPLAIN_DOMAIN_RESTRICTION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_DOMAIN_RESTRICTION]

	yyvs6: SPECIAL [XPLAIN_DOMAIN_RESTRICTION]
			-- Stack for semantic values of type XPLAIN_DOMAIN_RESTRICTION

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [XPLAIN_DOMAIN_RESTRICTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_DOMAIN_RESTRICTION]

	yyvs7: SPECIAL [XPLAIN_A_NODE]
			-- Stack for semantic values of type XPLAIN_A_NODE

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [XPLAIN_A_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_A_NODE]

	yyvs8: SPECIAL [XPLAIN_I_NODE]
			-- Stack for semantic values of type XPLAIN_I_NODE

	yyvsc8: INTEGER
			-- Capacity of semantic value stack `yyvs8'

	yyvsp8: INTEGER
			-- Top of semantic value stack `yyvs8'

	yyspecial_routines8: KL_SPECIAL_ROUTINES [XPLAIN_I_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_I_NODE]

	yyvs9: SPECIAL [XPLAIN_LOGICAL_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_LOGICAL_EXPRESSION

	yyvsc9: INTEGER
			-- Capacity of semantic value stack `yyvs9'

	yyvsp9: INTEGER
			-- Top of semantic value stack `yyvs9'

	yyspecial_routines9: KL_SPECIAL_ROUTINES [XPLAIN_LOGICAL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_LOGICAL_EXPRESSION]

	yyvs10: SPECIAL [XPLAIN_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_EXPRESSION

	yyvsc10: INTEGER
			-- Capacity of semantic value stack `yyvs10'

	yyvsp10: INTEGER
			-- Top of semantic value stack `yyvs10'

	yyspecial_routines10: KL_SPECIAL_ROUTINES [XPLAIN_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXPRESSION]

	yyvs11: SPECIAL [XPLAIN_LOGICAL_VALUE_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_LOGICAL_VALUE_EXPRESSION

	yyvsc11: INTEGER
			-- Capacity of semantic value stack `yyvs11'

	yyvsp11: INTEGER
			-- Top of semantic value stack `yyvs11'

	yyspecial_routines11: KL_SPECIAL_ROUTINES [XPLAIN_LOGICAL_VALUE_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_LOGICAL_VALUE_EXPRESSION]

	yyvs12: SPECIAL [XPLAIN_SYSTEM_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_SYSTEM_EXPRESSION

	yyvsc12: INTEGER
			-- Capacity of semantic value stack `yyvs12'

	yyvsp12: INTEGER
			-- Top of semantic value stack `yyvs12'

	yyspecial_routines12: KL_SPECIAL_ROUTINES [XPLAIN_SYSTEM_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_SYSTEM_EXPRESSION]

	yyvs13: SPECIAL [XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE_NAME_NODE

	yyvsc13: INTEGER
			-- Capacity of semantic value stack `yyvs13'

	yyvsp13: INTEGER
			-- Top of semantic value stack `yyvs13'

	yyspecial_routines13: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE_NAME_NODE]

	yyvs14: SPECIAL [XPLAIN_ATTRIBUTE_NAME]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE_NAME

	yyvsc14: INTEGER
			-- Capacity of semantic value stack `yyvs14'

	yyvsp14: INTEGER
			-- Top of semantic value stack `yyvs14'

	yyspecial_routines14: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE_NAME]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE_NAME]

	yyvs15: SPECIAL [detachable XPLAIN_TYPE]
			-- Stack for semantic values of type detachable XPLAIN_TYPE

	yyvsc15: INTEGER
			-- Capacity of semantic value stack `yyvs15'

	yyvsp15: INTEGER
			-- Top of semantic value stack `yyvs15'

	yyspecial_routines15: KL_SPECIAL_ROUTINES [detachable XPLAIN_TYPE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_TYPE]

	yyvs16: SPECIAL [detachable XPLAIN_EXPRESSION]
			-- Stack for semantic values of type detachable XPLAIN_EXPRESSION

	yyvsc16: INTEGER
			-- Capacity of semantic value stack `yyvs16'

	yyvsp16: INTEGER
			-- Top of semantic value stack `yyvs16'

	yyspecial_routines16: KL_SPECIAL_ROUTINES [detachable XPLAIN_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_EXPRESSION]

	yyvs17: SPECIAL [XPLAIN_REPRESENTATION]
			-- Stack for semantic values of type XPLAIN_REPRESENTATION

	yyvsc17: INTEGER
			-- Capacity of semantic value stack `yyvs17'

	yyvsp17: INTEGER
			-- Top of semantic value stack `yyvs17'

	yyspecial_routines17: KL_SPECIAL_ROUTINES [XPLAIN_REPRESENTATION]
			-- Routines that ought to be in SPECIAL [XPLAIN_REPRESENTATION]

	yyvs18: SPECIAL [XPLAIN_PK_REPRESENTATION]
			-- Stack for semantic values of type XPLAIN_PK_REPRESENTATION

	yyvsc18: INTEGER
			-- Capacity of semantic value stack `yyvs18'

	yyvsp18: INTEGER
			-- Top of semantic value stack `yyvs18'

	yyspecial_routines18: KL_SPECIAL_ROUTINES [XPLAIN_PK_REPRESENTATION]
			-- Routines that ought to be in SPECIAL [XPLAIN_PK_REPRESENTATION]

	yyvs19: SPECIAL [detachable XPLAIN_ATTRIBUTE_NODE]
			-- Stack for semantic values of type detachable XPLAIN_ATTRIBUTE_NODE

	yyvsc19: INTEGER
			-- Capacity of semantic value stack `yyvs19'

	yyvsp19: INTEGER
			-- Top of semantic value stack `yyvs19'

	yyspecial_routines19: KL_SPECIAL_ROUTINES [detachable XPLAIN_ATTRIBUTE_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_ATTRIBUTE_NODE]

	yyvs20: SPECIAL [XPLAIN_ATTRIBUTE]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE

	yyvsc20: INTEGER
			-- Capacity of semantic value stack `yyvs20'

	yyvsp20: INTEGER
			-- Top of semantic value stack `yyvs20'

	yyspecial_routines20: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE]

	yyvs21: SPECIAL [detachable XPLAIN_ASSERTION]
			-- Stack for semantic values of type detachable XPLAIN_ASSERTION

	yyvsc21: INTEGER
			-- Capacity of semantic value stack `yyvs21'

	yyvsp21: INTEGER
			-- Top of semantic value stack `yyvs21'

	yyspecial_routines21: KL_SPECIAL_ROUTINES [detachable XPLAIN_ASSERTION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_ASSERTION]

	yyvs22: SPECIAL [detachable XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Stack for semantic values of type detachable XPLAIN_ATTRIBUTE_NAME_NODE

	yyvsc22: INTEGER
			-- Capacity of semantic value stack `yyvs22'

	yyvsp22: INTEGER
			-- Top of semantic value stack `yyvs22'

	yyspecial_routines22: KL_SPECIAL_ROUTINES [detachable XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_ATTRIBUTE_NAME_NODE]

	yyvs23: SPECIAL [detachable XPLAIN_ASSIGNMENT_NODE]
			-- Stack for semantic values of type detachable XPLAIN_ASSIGNMENT_NODE

	yyvsc23: INTEGER
			-- Capacity of semantic value stack `yyvs23'

	yyvsp23: INTEGER
			-- Top of semantic value stack `yyvs23'

	yyspecial_routines23: KL_SPECIAL_ROUTINES [detachable XPLAIN_ASSIGNMENT_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_ASSIGNMENT_NODE]

	yyvs24: SPECIAL [XPLAIN_ASSIGNMENT]
			-- Stack for semantic values of type XPLAIN_ASSIGNMENT

	yyvsc24: INTEGER
			-- Capacity of semantic value stack `yyvs24'

	yyvsp24: INTEGER
			-- Top of semantic value stack `yyvs24'

	yyspecial_routines24: KL_SPECIAL_ROUTINES [XPLAIN_ASSIGNMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_ASSIGNMENT]

	yyvs25: SPECIAL [detachable XPLAIN_SUBJECT]
			-- Stack for semantic values of type detachable XPLAIN_SUBJECT

	yyvsc25: INTEGER
			-- Capacity of semantic value stack `yyvs25'

	yyvsp25: INTEGER
			-- Top of semantic value stack `yyvs25'

	yyspecial_routines25: KL_SPECIAL_ROUTINES [detachable XPLAIN_SUBJECT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_SUBJECT]

	yyvs26: SPECIAL [detachable XPLAIN_NON_ATTRIBUTE_EXPRESSION]
			-- Stack for semantic values of type detachable XPLAIN_NON_ATTRIBUTE_EXPRESSION

	yyvsc26: INTEGER
			-- Capacity of semantic value stack `yyvs26'

	yyvsp26: INTEGER
			-- Top of semantic value stack `yyvs26'

	yyspecial_routines26: KL_SPECIAL_ROUTINES [detachable XPLAIN_NON_ATTRIBUTE_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_NON_ATTRIBUTE_EXPRESSION]

	yyvs27: SPECIAL [detachable XPLAIN_SELECTION_FUNCTION]
			-- Stack for semantic values of type detachable XPLAIN_SELECTION_FUNCTION

	yyvsc27: INTEGER
			-- Capacity of semantic value stack `yyvs27'

	yyvsp27: INTEGER
			-- Top of semantic value stack `yyvs27'

	yyspecial_routines27: KL_SPECIAL_ROUTINES [detachable XPLAIN_SELECTION_FUNCTION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_SELECTION_FUNCTION]

	yyvs28: SPECIAL [detachable XPLAIN_EXTENSION]
			-- Stack for semantic values of type detachable XPLAIN_EXTENSION

	yyvsc28: INTEGER
			-- Capacity of semantic value stack `yyvs28'

	yyvsp28: INTEGER
			-- Top of semantic value stack `yyvs28'

	yyspecial_routines28: KL_SPECIAL_ROUTINES [detachable XPLAIN_EXTENSION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_EXTENSION]

	yyvs29: SPECIAL [XPLAIN_EXTEND_ATTRIBUTE]
			-- Stack for semantic values of type XPLAIN_EXTEND_ATTRIBUTE

	yyvsc29: INTEGER
			-- Capacity of semantic value stack `yyvs29'

	yyvsp29: INTEGER
			-- Top of semantic value stack `yyvs29'

	yyspecial_routines29: KL_SPECIAL_ROUTINES [XPLAIN_EXTEND_ATTRIBUTE]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXTEND_ATTRIBUTE]

	yyvs30: SPECIAL [detachable XPLAIN_EXTENSION_EXPRESSION]
			-- Stack for semantic values of type detachable XPLAIN_EXTENSION_EXPRESSION

	yyvsc30: INTEGER
			-- Capacity of semantic value stack `yyvs30'

	yyvsp30: INTEGER
			-- Top of semantic value stack `yyvs30'

	yyspecial_routines30: KL_SPECIAL_ROUTINES [detachable XPLAIN_EXTENSION_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_EXTENSION_EXPRESSION]

	yyvs31: SPECIAL [detachable XPLAIN_SELECTION]
			-- Stack for semantic values of type detachable XPLAIN_SELECTION

	yyvsc31: INTEGER
			-- Capacity of semantic value stack `yyvs31'

	yyvsp31: INTEGER
			-- Top of semantic value stack `yyvs31'

	yyspecial_routines31: KL_SPECIAL_ROUTINES [detachable XPLAIN_SELECTION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_SELECTION]

	yyvs32: SPECIAL [detachable XPLAIN_SELECTION_LIST]
			-- Stack for semantic values of type detachable XPLAIN_SELECTION_LIST

	yyvsc32: INTEGER
			-- Capacity of semantic value stack `yyvs32'

	yyvsp32: INTEGER
			-- Top of semantic value stack `yyvs32'

	yyspecial_routines32: KL_SPECIAL_ROUTINES [detachable XPLAIN_SELECTION_LIST]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_SELECTION_LIST]

	yyvs33: SPECIAL [detachable XPLAIN_SORT_NODE]
			-- Stack for semantic values of type detachable XPLAIN_SORT_NODE

	yyvsc33: INTEGER
			-- Capacity of semantic value stack `yyvs33'

	yyvsp33: INTEGER
			-- Top of semantic value stack `yyvs33'

	yyspecial_routines33: KL_SPECIAL_ROUTINES [detachable XPLAIN_SORT_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_SORT_NODE]

	yyvs34: SPECIAL [XPLAIN_FUNCTION]
			-- Stack for semantic values of type XPLAIN_FUNCTION

	yyvsc34: INTEGER
			-- Capacity of semantic value stack `yyvs34'

	yyvsp34: INTEGER
			-- Top of semantic value stack `yyvs34'

	yyspecial_routines34: KL_SPECIAL_ROUTINES [XPLAIN_FUNCTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_FUNCTION]

	yyvs35: SPECIAL [detachable XPLAIN_EXPRESSION_NODE]
			-- Stack for semantic values of type detachable XPLAIN_EXPRESSION_NODE

	yyvsc35: INTEGER
			-- Capacity of semantic value stack `yyvs35'

	yyvsp35: INTEGER
			-- Top of semantic value stack `yyvs35'

	yyspecial_routines35: KL_SPECIAL_ROUTINES [detachable XPLAIN_EXPRESSION_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_EXPRESSION_NODE]

	yyvs36: SPECIAL [detachable STRING]
			-- Stack for semantic values of type detachable STRING

	yyvsc36: INTEGER
			-- Capacity of semantic value stack `yyvs36'

	yyvsp36: INTEGER
			-- Top of semantic value stack `yyvs36'

	yyspecial_routines36: KL_SPECIAL_ROUTINES [detachable STRING]
			-- Routines that ought to be in SPECIAL [detachable STRING]

	yyvs37: SPECIAL [detachable XPLAIN_STATEMENT_NODE]
			-- Stack for semantic values of type detachable XPLAIN_STATEMENT_NODE

	yyvsc37: INTEGER
			-- Capacity of semantic value stack `yyvs37'

	yyvsp37: INTEGER
			-- Top of semantic value stack `yyvs37'

	yyspecial_routines37: KL_SPECIAL_ROUTINES [detachable XPLAIN_STATEMENT_NODE]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_STATEMENT_NODE]

	yyvs38: SPECIAL [detachable XPLAIN_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_STATEMENT

	yyvsc38: INTEGER
			-- Capacity of semantic value stack `yyvs38'

	yyvsp38: INTEGER
			-- Top of semantic value stack `yyvs38'

	yyspecial_routines38: KL_SPECIAL_ROUTINES [detachable XPLAIN_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_STATEMENT]

	yyvs39: SPECIAL [detachable XPLAIN_CONSTANT_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_CONSTANT_STATEMENT

	yyvsc39: INTEGER
			-- Capacity of semantic value stack `yyvs39'

	yyvsp39: INTEGER
			-- Top of semantic value stack `yyvs39'

	yyspecial_routines39: KL_SPECIAL_ROUTINES [detachable XPLAIN_CONSTANT_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_CONSTANT_STATEMENT]

	yyvs40: SPECIAL [detachable XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT

	yyvsc40: INTEGER
			-- Capacity of semantic value stack `yyvs40'

	yyvsp40: INTEGER
			-- Top of semantic value stack `yyvs40'

	yyspecial_routines40: KL_SPECIAL_ROUTINES [detachable XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]

	yyvs41: SPECIAL [detachable XPLAIN_CASCADE_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_CASCADE_STATEMENT

	yyvsc41: INTEGER
			-- Capacity of semantic value stack `yyvs41'

	yyvsp41: INTEGER
			-- Top of semantic value stack `yyvs41'

	yyspecial_routines41: KL_SPECIAL_ROUTINES [detachable XPLAIN_CASCADE_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_CASCADE_STATEMENT]

	yyvs42: SPECIAL [detachable XPLAIN_CASCADE_FUNCTION_EXPRESSION]
			-- Stack for semantic values of type detachable XPLAIN_CASCADE_FUNCTION_EXPRESSION

	yyvsc42: INTEGER
			-- Capacity of semantic value stack `yyvs42'

	yyvsp42: INTEGER
			-- Top of semantic value stack `yyvs42'

	yyspecial_routines42: KL_SPECIAL_ROUTINES [detachable XPLAIN_CASCADE_FUNCTION_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_CASCADE_FUNCTION_EXPRESSION]

	yyvs43: SPECIAL [detachable XPLAIN_DELETE_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_DELETE_STATEMENT

	yyvsc43: INTEGER
			-- Capacity of semantic value stack `yyvs43'

	yyvsp43: INTEGER
			-- Top of semantic value stack `yyvs43'

	yyspecial_routines43: KL_SPECIAL_ROUTINES [detachable XPLAIN_DELETE_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_DELETE_STATEMENT]

	yyvs44: SPECIAL [detachable XPLAIN_EXTEND_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_EXTEND_STATEMENT

	yyvsc44: INTEGER
			-- Capacity of semantic value stack `yyvs44'

	yyvsp44: INTEGER
			-- Top of semantic value stack `yyvs44'

	yyspecial_routines44: KL_SPECIAL_ROUTINES [detachable XPLAIN_EXTEND_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_EXTEND_STATEMENT]

	yyvs45: SPECIAL [detachable XPLAIN_GET_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_GET_STATEMENT

	yyvsc45: INTEGER
			-- Capacity of semantic value stack `yyvs45'

	yyvsp45: INTEGER
			-- Top of semantic value stack `yyvs45'

	yyspecial_routines45: KL_SPECIAL_ROUTINES [detachable XPLAIN_GET_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_GET_STATEMENT]

	yyvs46: SPECIAL [detachable XPLAIN_PROCEDURE_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_PROCEDURE_STATEMENT

	yyvsc46: INTEGER
			-- Capacity of semantic value stack `yyvs46'

	yyvsp46: INTEGER
			-- Top of semantic value stack `yyvs46'

	yyspecial_routines46: KL_SPECIAL_ROUTINES [detachable XPLAIN_PROCEDURE_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_PROCEDURE_STATEMENT]

	yyvs47: SPECIAL [XPLAIN_SQL_STATEMENT]
			-- Stack for semantic values of type XPLAIN_SQL_STATEMENT

	yyvsc47: INTEGER
			-- Capacity of semantic value stack `yyvs47'

	yyvsp47: INTEGER
			-- Top of semantic value stack `yyvs47'

	yyspecial_routines47: KL_SPECIAL_ROUTINES [XPLAIN_SQL_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_SQL_STATEMENT]

	yyvs48: SPECIAL [detachable XPLAIN_UPDATE_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_UPDATE_STATEMENT

	yyvsc48: INTEGER
			-- Capacity of semantic value stack `yyvs48'

	yyvsp48: INTEGER
			-- Top of semantic value stack `yyvs48'

	yyspecial_routines48: KL_SPECIAL_ROUTINES [detachable XPLAIN_UPDATE_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_UPDATE_STATEMENT]

	yyvs49: SPECIAL [XPLAIN_VALUE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_VALUE_STATEMENT

	yyvsc49: INTEGER
			-- Capacity of semantic value stack `yyvs49'

	yyvsp49: INTEGER
			-- Top of semantic value stack `yyvs49'

	yyspecial_routines49: KL_SPECIAL_ROUTINES [XPLAIN_VALUE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_VALUE_STATEMENT]

	yyvs50: SPECIAL [detachable XPLAIN_VALUE_SELECTION_STATEMENT]
			-- Stack for semantic values of type detachable XPLAIN_VALUE_SELECTION_STATEMENT

	yyvsc50: INTEGER
			-- Capacity of semantic value stack `yyvs50'

	yyvsp50: INTEGER
			-- Top of semantic value stack `yyvs50'

	yyspecial_routines50: KL_SPECIAL_ROUTINES [detachable XPLAIN_VALUE_SELECTION_STATEMENT]
			-- Routines that ought to be in SPECIAL [detachable XPLAIN_VALUE_SELECTION_STATEMENT]

feature {NONE} -- Constants

	yyFinal: INTEGER = 636
			-- Termination state id

	yyFlag: INTEGER = -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER = 131
			-- Number of tokens

	yyLast: INTEGER = 1879
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER = 366
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER = 270
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



feature -- Initialization

	make_with_file (a_file: KI_CHARACTER_INPUT_STREAM; a_sqlgenerator: SQL_GENERATOR)
		do
			make_scanner_with_file (a_file)
			make (a_sqlgenerator)
		end

	make_with_stdin (a_sqlgenerator: SQL_GENERATOR)
		do
			make_scanner_with_stdin
			make (a_sqlgenerator)
		end


feature {NONE} -- private creation

	make (a_sqlgenerator: SQL_GENERATOR)
		do
			make_parser_skeleton
			create statements.make
			set_sqlgenerator (a_sqlgenerator)
			-- Set some dummy values so we can avoid using detachable
			create {XPLAIN_REQUIRED} dummyrestriction.make (True)
		end


feature {NONE} -- dummy variables to store created objects in

	dummya: detachable XPLAIN_A_REFERENCES
	dummyi: detachable XPLAIN_I_REFERENCES
	dummye: detachable XPLAIN_EXPRESSION
	dummybool: detachable XPLAIN_LOGICAL_VALUE_EXPRESSION
	dummyrestriction: XPLAIN_DOMAIN_RESTRICTION

	last_width: INTEGER
			-- saves latest domain width, for example I2 will save 2 here

feature {NONE} -- local variables, do not survive outside a code block!

	mybase: detachable XPLAIN_BASE
	myvariable: detachable XPLAIN_VARIABLE
	myindex: detachable XPLAIN_INDEX
	current_type_name: detachable STRING
	auto_identifier: BOOLEAN
	my_selection_function: detachable XPLAIN_SELECTION_FUNCTION

	is_init_default: BOOLEAN
			-- Determine if init or init default statement has to be created.


feature {NONE} -- these vars survive a little bit longer

	subject_type: detachable XPLAIN_TYPE  -- used to check if valid attribute
	extend_type: detachable XPLAIN_TYPE   -- used in extend statement
	my_parameters: detachable XPLAIN_ATTRIBUTE_NAME_NODE
			-- List of declared parameters for a procedure

	constant_mode: BOOLEAN
			-- Are we parsing a constant expression?


feature -- Xplain

	statements: XPLAIN_STATEMENTS
			-- All executable statements.


feature {NONE} -- Expression generation

	new_logical_expression (a_left: XPLAIN_EXPRESSION; an_operator: STRING; a_right: XPLAIN_EXPRESSION): XPLAIN_LOGICAL_EXPRESSION
		local
			e: XPLAIN_EXPRESSION
		do
			create {XPLAIN_LOGICAL_INFIX_EXPRESSION} e.make (a_left, an_operator, a_right)
			create Result.make (e)
		end

	new_logical_infix_expression (a_left: XPLAIN_EXPRESSION; an_operator: STRING; a_right: XPLAIN_EXPRESSION): XPLAIN_INFIX_EXPRESSION
			-- Create a new infix expression. It's main purpose is to
			-- determine when to use the like operator instead of the '='
			-- operator.
		require
			valid_left: a_left /= Void
			valid_right: a_right /= Void
			operator_not_empty: an_operator /= Void and then not an_operator.is_empty
		local
			equal_operator,
			not_equal_operator: BOOLEAN
			r: detachable XPLAIN_INFIX_EXPRESSION
		do
			if an_operator.same_string (once_equal) then
				equal_operator := True
			elseif an_operator.same_string (once_not_equal) then
				not_equal_operator := True
			end
			if equal_operator or else not_equal_operator then
				if a_left.has_wild_card_characters or a_right.has_wild_card_characters then
					if equal_operator then
						create {XPLAIN_LIKE_EXPRESSION} r.make (a_left, a_right)
					else
						create {XPLAIN_NOT_LIKE_EXPRESSION} r.make (a_left, a_right)
					end
				end
			end

			-- Fallback to standard infix expression.
			if not attached r then
				create {XPLAIN_LOGICAL_INFIX_EXPRESSION} r.make (a_left, an_operator, a_right)
			end
			Result := r
		ensure
			new_infix_expression_not_void: Result /= Void
		end


feature -- Code blocks

	new_base (a_name: STRING; a_definition: XPLAIN_REPRESENTATION; a_required: BOOLEAN): XPLAIN_BASE
		local
			r: XPLAIN_DOMAIN_RESTRICTION
		do
			if not attached a_definition.domain_restriction then
				if a_definition.domain.is_equal ("(B)") then
					create {XPLAIN_B_RESTRICTION} r.make (a_required)
				else
					create {XPLAIN_REQUIRED} r.make (a_required)
				end
				a_definition.set_domain_restriction (sqlgenerator, r)
			end
			create Result.make (a_name, a_definition)
		end

	newdate_default_days: XPLAIN_STRING_EXPRESSION
		once
			create {XPLAIN_STRING_EXPRESSION} Result.make ("days")
		end


feature -- Statement generation

	new_procedure_statement (a_name: STRING; a_parameters: detachable XPLAIN_ATTRIBUTE_NAME_NODE; a_procedure_kind: INTEGER; a_statements: detachable XPLAIN_STATEMENT_NODE): XPLAIN_PROCEDURE_STATEMENT
		local
			myprocedure: XPLAIN_PROCEDURE
		do
			create myprocedure.make (a_name, a_parameters, a_procedure_kind, a_statements)
			create Result.make (myprocedure)
		end

	new_value_statement (an_sqlgenerator: SQL_GENERATOR; a_name: STRING; an_expression: XPLAIN_EXPRESSION): XPLAIN_VALUE_STATEMENT
		local
			myvalue: XPLAIN_VALUE
		do
			create myvalue.make (an_sqlgenerator, a_name, an_expression)
			create Result.make (myvalue)
		end


feature -- Silence compiler

	silence_compiler_logical_expression: XPLAIN_LOGICAL_VALUE_EXPRESSION
		once
			create {XPLAIN_LOGICAL_VALUE_EXPRESSION} Result.make (False)
		end

	silence_compiler_expression: XPLAIN_EXPRESSION
		once
			create {XPLAIN_STRING_EXPRESSION} Result.make ("")
		end


feature -- Middleware

	mwgenerator: detachable MIDDLEWARE_GENERATOR

	set_mwgenerator (mwg: MIDDLEWARE_GENERATOR)
		do
			mwgenerator := mwg
		end


feature {NONE} -- Error handling

	error_unknown_attribute (a_type: STRING; an_attribute: XPLAIN_ATTRIBUTE_NAME)
			-- abort with unknown attribute error
		local
			s: STRING
		do
			s := "Type `" + a_type + "' does not have the attribute `"
			if attached an_attribute.role as r then
				s := s + r + "_"
			end
			s := s + an_attribute.name + "'."
			report_error (s)
			abort
		end

feature {NONE} -- pending statements

	pending_type: detachable XPLAIN_TYPE
			-- set for type not yet written

	write_pending_init
		require
			pending_type_written: pending_init = Void or else pending_type = Void
		do
			if attached pending_init as pi then
				if not use_mode then
					sqlgenerator.write_init (pi)
				end
				pending_init := Void
			end
		ensure
			pending_init_void: pending_init = Void
		end

	write_pending_statement
			-- Call this before outputting anything!
		do
			write_pending_type
			write_pending_init
		ensure then
			pending_init_void: pending_init = Void
		end

	write_pending_type
		do
			if attached pending_type as t then
				if not use_mode then
					sqlgenerator.write_type (t)
					if attached mwgenerator as g then
						g.dump_type (t, sqlgenerator)
					end
				end
				pending_type := Void
			end
		ensure
			pending_type_void: pending_type = Void
		end


feature {NONE} -- Checks for validness of parsed code

	get_known_base_or_type (name: STRING): detachable XPLAIN_ABSTRACT_TYPE
			-- Test if known type, but be aware of self-reference.
		do
			Result := universe.find_base_or_type (name)
			if not attached Result and then
				not equal(current_type_name, name) then
				report_error ("Unknown base or type: " + name)
				abort
			end
		end

	get_known_object (name: STRING): detachable XPLAIN_ABSTRACT_OBJECT
			-- Return object, must exist.
		do
			Result := universe.find_object (name)
			if not attached Result then
				report_error ("Not a defined object: " + name)
				abort
			end
		end

	get_known_type (name: STRING): detachable XPLAIN_TYPE
			-- Return the type for `name' or die.
		local
			b: detachable XPLAIN_BASE
		do
			Result := universe.find_type (name)
			if not attached Result then
				b := universe.find_base (name)
				if not attached b then
					report_error ("Type unknown: " + name)
				else
					report_error (format ("`$s' is a base, but a type is expected here.", <<name>>))
				end
				abort
			end
		end

	get_known_value (name: STRING): detachable XPLAIN_VALUE
		do
			Result := universe.find_value (name)
			if not attached Result then
				report_error ("Value unknown: " + name)
				abort
			end
		end

	last_object_in_tree: detachable XPLAIN_ABSTRACT_OBJECT
			-- Set by `get_object_if_valid_tree' to last object in list.

	get_object_if_valid_tree (first: XPLAIN_ATTRIBUTE_NAME_NODE): detachable XPLAIN_ABSTRACT_OBJECT
			-- The object for the first name of this tree, if this
			-- is a valid tree;
			-- Also augment tree with type information.
		require
			first_not_void: first /= Void
			subject_type_set: attached subject_type
		local
			my_attribute: detachable XPLAIN_ATTRIBUTE
			node: detachable XPLAIN_ATTRIBUTE_NAME_NODE
			preceding_type: XPLAIN_TYPE
			atype: detachable XPLAIN_ABSTRACT_TYPE
			valid_attribute: BOOLEAN
			msg: STRING
		do
			last_object_in_tree := Void
			check attached subject_type as my_subject_type then
				if attached first.next then
					-- Something like a its b its c, should all be attributes.
					from
						node := first
						preceding_type := my_subject_type
						valid_attribute := True
					until
						node = Void or
						not valid_attribute
					loop
						my_attribute := preceding_type.find_attribute (node.item)
						if attached my_attribute then
							valid_attribute := True
						end
						if valid_attribute and attached my_attribute as a then
							node.item.set_attribute (a)
							atype := a.abstracttype
							--node.item.set_object (atype)
							if node.next /= Void then
								if attached {XPLAIN_TYPE} atype as t then
									preceding_type := t
								else
									-- we've a base here (but missed extension
									-- because it's a type, need to fix this)
									valid_attribute := False
									report_error ("A base cannot have attributes. Base name is: " + node.item.name)
									abort
								end
							end
						else -- type doesn't have this attribute
							valid_attribute := False
							report_error ("Type " + preceding_type.name + " doesn't have the attribute: " + node.item.name)
							abort
						end
						node := node.next
					end
					if valid_attribute then
						last_object_in_tree := atype
						check attached my_subject_type.find_attribute (first.item) as a then
							Result := a.abstracttype
						end
					end
				else
					-- Can be value/variable or attribute.
					-- Check attribute first.
					my_attribute := my_subject_type.find_attribute (first.item)
					if attached my_attribute then
						first.item.set_attribute (my_attribute)
						Result := my_attribute.abstracttype
					else
						Result := universe.find_object (first.item.name)
						if attached {XPLAIN_VALUE} Result as value then
							-- variable or constants are OK
							-- I probably don't detect cases
							first.item.set_object (value)
						elseif attached {XPLAIN_VARIABLE} Result as variable then
							first.item.set_object (variable)
						elseif attached Result then
							create msg.make (128)
							msg.append_string ("base/type '")
							if first.item.role /= Void then
								msg.append_string (first.item.role)
								msg.append_string ("_")
							end
							msg.append_string (first.item.name)
							msg.append_string ("' is not an attribute of '")
							msg.append_string (my_subject_type.name)
							msg.append_string ("'%N")
							report_error (msg)
							abort
							Result := Void
						else
							-- Doesn't exist in universe at all
							report_error ( format("`$s' is not an attribute of type `$s', nor a value or constant.", <<first.item.full_name, my_subject_type.name>>))
							abort
							Result := Void
						end
					end
					if attached Result then
						last_object_in_tree := Result
					end
				end
			end
		ensure
			if_not_valid_tree: True -- Warnings are given
			if_valid_tree: True
			-- Result /= Void and object is the object for the first name
			-- in the tree
			last_object_set: Result /= Void implies last_object_in_tree /= Void
		end

	is_parameter_declared (a_name: XPLAIN_ATTRIBUTE_NAME): BOOLEAN
			-- Has `a_name' been declared in the parameter list for the
			-- current procedure?
		require
			name_not_empty: a_name /= Void
		do
			Result := attached my_parameters as p and then p.has (a_name)
			if not Result then
				report_error ("Parameter `" + a_name.full_name + "' has not been declared.")
				abort
			end
		end


feature {NONE} -- Checks

	warn_attributes_with_inits (an_assignment_list: XPLAIN_ASSIGNMENT_NODE)
			-- Check if user has specified an attribute for which an init
			-- expression exists. Assignment will be (should be...)
			-- ignored in that case.
		require
			an_assignment_list_not_void: an_assignment_list /= Void
		local
			node: detachable XPLAIN_ASSIGNMENT_NODE
		do
			from
				node := an_assignment_list
			until
				node = Void
			loop
				if
					attached node.item.attribute_name.type_attribute as type_attribute and then
					attached type_attribute.init and then
					not type_attribute.is_init_default
				then
					report_error (format ("Attribute $s has an init expression. Assignment specified in insert will be ignored.%N", <<node.item.attribute_name.full_name>>))
				end
				node := node.next
			end
		end


feature {NONE} -- Once strings

	once_equal: STRING = "="
	once_not_equal: STRING = "<>"


end
